; Compiler: Avrasm2

; [ATmega32A]
#include "m32Adef.inc"

;                 "1234567812345678
#define sourceP   "EarTest9_01_01__" ; of Project
#define sourceB   "ET9_01_01_______" ; for Boards
#define HEX_year  0x24
#define HEX_month 0x11
#define HEX_day   0x27
; __DATE__ , __TIME__ are in bin file

;====
.DSEG
;====

    .org 0x0060

FindexL:  .Byte 1 ;60 frequecy basic index, 0 to 484, low
FindexH:  .Byte 1 ;61 frequecy basic index, 0 to 484, high

bandIdx:  .Byte 1 ;62 0 to 4
lowBand:  .Byte 1 ;63 0= hiBands, 1=loBands

; from 96 to 3088 bits
Nbits_L:  .Byte 1 ;64 number of delta stream bits of one cycle, low
Nbits_H:  .Byte 1 ;65 number of delta stream bits of one cycle, high

NangleL:  .Byte 1 ;66 number of angles for step x [Nbits_H\L / x], low
NangleH:  .Byte 1 ;67 number of angles for step x [Nbits_H\L / x], high

Nloop_L:  .Byte 1 ;68 temporary forloops, low
Nloop_H:  .Byte 1 ;69 temporary forloops, high

; delta step for a nominal amplitude at LPF output
dvFd_pL:  .Byte 1 ;6A positive delta step, low
dvFd_pH:  .Byte 1 ;6B positive delta step, high

dvFd_nL:  .Byte 1 ;6C negative delta step, low
dvFd_nH:  .Byte 1 ;6D negative delta step, high

V_fdb_L:  .Byte 1 ;6E accumulate delta steps, low
V_fdb_H:  .Byte 1 ;6F accumulate delta steps, high

TWIstep:  .Byte 1 ;70 send 0=START, 1=SLA_W, 2=addrH, 3=addrL, 4=data [DLT_tbl]
TWIstat:  .Byte 1 ;71 the expected TWI next status

;===

SINendL:  .Byte 1 ;72 last SRAM address of SIN list (0 to PI/4), low
SINendH:  .Byte 1 ;73 last SRAM address of SIN list (0 to PI/4), high

; delta step, variable
dvFd_L:   .Byte 1 ;74 delta step [TMR1], low
dvFd_H:   .Byte 1 ;75 delta step [TMR1], high

EEaddrL:  .Byte 1 ;76 EE address of dvFd_H\L, low
EEaddrH:  .Byte 1 ;77 EE address of dvFd_H\L, high

indexL:   .Byte 1 ;78 frequecy index, 0 to 969, low  [hiBands   0 to 484]
indexH:   .Byte 1 ;79 frequecy index, 0 to 969, high [loBands 485 to 969]

prvDv_L:  .Byte 1 ;7A previous delta step, low
prvDv_H:  .Byte 1 ;7B previous delta step, high

hiDvFdL:  .Byte 1 ;7C previous upper limt of delta step, low
hiDvFdH:  .Byte 1 ;7D previous upper limt of delta step, high

loDvFdL:  .Byte 1 ;7E previous lower limt of delta step, low
loDvFdH:  .Byte 1 ;7F previous lower limt of delta step, high

FFTsumL:  .Byte 1 ;80 sum of sine entries of Q1 * delta bit, low
FFTsumH:  .Byte 1 ;81 sum of sine entries of Q1 * delta bit, high

FFTdifL:  .Byte 1 ;82 ABS(FFTsumH\L - Apeak), low
FFTdifH:  .Byte 1 ;83 ABS(FFTsumH\L - Apeak), high

sumFFTL:  .Byte 1 ;84 FFTsumH\L at FFTdifH\L, low
sumFFTH:  .Byte 1 ;85 FFTsumH\L at FFTdifH\L, high

FFTdvFL:  .Byte 1 ;86 dvFd_H\L at FFTdifH\L, low
FFTdvFH:  .Byte 1 ;87 dvFd_H\L at FFTdifH\L, low

NfreqL:   .Byte 1 ;88 for many bands test, frequencies number, low
NfreqH:   .Byte 1 ;89 for many bands test, frequencies number, high

; SRAM space above = up to 72 bytes only [0xA7]

;===

    .org 0x00A8
SINpFw1_4:
;[up to 776 bytes]

    .org 0x03B0
COSpFw1_4:
;[up to 776 bytes]

    .org 0x06B8
DLT_tbl:
;[up to 388 bytes]

; 0x083C
; stack space up to 36 bytes [18 calls]

;---------------------

; for loop, to clear registers
.equ SRAMstr = 0x60             ; up to 0x00FF (160 SRAM bytes)

;---------------------

;====
.CSEG
;====

;==========================
; **** SYSTEM constants ***
;==========================
; ADC7, ADC6, ADC5, ADC4, ADC3, ADC2, ADC1, ADC0
; NA3=inP,NA2=inP,NA1=inP,NXT=inP,H3=inP,H2=inP,H1=inP,H0=inP
.equ DDRAini0 = 0b000_0_0000   ; iii i iii i
.equ PRTAini0 = 0b111_1_1111   ; PPP P PPP P

; *** inputs *** 5
#define freq2In PINA            ; for BCD hundreds and next frequency SW
#define nxtF_In PINA,4          ; next frequency SW

; *** outputs *** 0
; none

; *** reserved *** 3
; PA5, PB6, PB7

;======

; SCK, MISO, MOSI, SS, OC0/AIN1, T2/AIN0, T1, T0/XCK
; B7=outL,B6=outL,B5=outL,B4=outL,B3=outL,B2=outL,B1=outL,DLT=outH
.equ DDRBini0 = 0b11111111      ; oooooooo
.equ PRTBini0 = 0b00000000      ; LLLLLLLL

; *** inputs *** 0
; none

; *** outputs *** 8 [though PD0 only used to output the bits of delta stream]
#define DLT_Out PORTB           ; for DO_wave, a reference only
#define DLT0Out PORTB,7         ; high when no wave [to reset FDB to high]

; *** reserved *** 0
; none

;======

; TOSC2, TOSC1, TDI, TDO, TMS, TCK, SDA, SCL
; T3=inP,T2=inP,T1=inP,T0=inP,U3=inP,U2=inP,U1=inP,U0=inP
.equ DDRCini0  = 0b0000_0000     ; iiii iiii
.equ PRTCini0  = 0b1111_1111     ; PPPP PPPP

; *** inputs *** 8
#define freq1In PINC             ; for BCD units and tens

; *** outputs *** 0
; none

; *** reserved *** 0
; none

;======

; OC2, ICP1, OC1A, OC1B, INT1, INT0, TXD, RXD
; ,ND2=inP,BUSY=outH,SYNC=outL,ND1=inP,GG=outL,G3=inT,G2=inT,G1=inT
.equ DDRDini0 = 0b0_11_0_1_000  ; i oo i o iii
.equ PRTDini0 = 0b1_10_1_0_000  ; P HL P L TTT

; *** inputs *** 0
; none

; *** outputs *** 3+3
; 1=calc, 0=wave
#define busyOut PORTD,6         ; 1= LED On

; Falling edge of syncOut signals the end of wave cycle
; or
; if NOcard, LED Flipped LED [2s/2s On/Off]
#define syncOut PORTD,5         ; 1= LED On

; If 3-RC LPF, 3 capacitors are grounded if loBands
#define Band_Out PORD
.equ HiBndDDR=0b0_11_0_1_000
.equ LoBndDDR=0b0_11_0_1_111

; *** reserved *** 2
; PD4, PD7

;==========================
; *** PROGRAM constants ***
;==========================

.equ FidxBnd =  97

.equ EndBnd0 = FidxBnd-1        ;  96
.equ EndBnd1 = EndBnd0+FidxBnd  ; 193
.equ EndBnd2 = EndBnd1+FidxBnd  ; 290
.equ EndBnd3 = EndBnd2+FidxBnd  ; 387
.equ EndBnd4 = EndBnd3+FidxBnd  ; 484

.equ LoBands = EndBnd4+1        ; 485, Lowest  indexH\L of loBands
.equ FidxMax = EndBnd4+LoBands  ; 969, highest indexH\L of loBands
; <todo> if indexH\L > HiIndex, special frequencies

.equ Cos0Min = 16349            ; of indexH\L=0 or 485, 96 bits
; cos0H\L = Cos0Min + cos0_diff [see cosSinE: and table SinCos0:]

;=== ===

.equ Soffset = 32768            ; sine/cosine offset, 2^16/2=2^15
.equ COSpeak = 16384            ; sine/cosine peak,   2^16/4=2^14

;=============================
; *** PROGRAM hi-registers ***
;=============================
; specific hi-registers
.def SINnewH = r25    ; new sinus   in delta loop, high
.def SINnewL = r24    ; new sinus   in delta loop, low
.def COSnewH = r23    ; new cosinus in delta loop, high
.def COSnewL = r22    ; new cosinus in delta loop, low

.def SINnxtH = r23    ; next sinus in delta loop, high
.def SINnxtL = r22    ; next sinus in delta loop, low

; GLOBAL  hi-registers during tables calc
;.def tmpHiH   = r19   ; tempprary register
;.def tmpHiL   = r18   ; tempprary register

;===

; Specific hi-registers during wave loop
.def counter  = r23
.def nextByte = r22

.def lastBytH = r21   ; of delta table
.def lastBytL = r20

.def frstBytH = r17   ; of delta table
.def frstBytL = r16

;=============================
; *** PROGRAM lo-registers ***
;=============================
; specific lo-registers
.def zero   = r15     ; as 0
.def PLSbyte= r14     ; for delta bits

;====== step 1 ======
.def sin0H  = r13     ; sinus   of delta step, high
.def sin0L  = r12     ; sinus   of delta step, low
.def cos0H  = r11     ; cosinus of delta step, high
.def cos0L  = r10     ; cosinus of delta step, low

.def SINprvH= r9      ; previous sinus   in delta loop, high
.def SINprvL= r8      ; previous sinus   in delta loop, low
.def COSprvH= r7      ; previous cosinus in delta loop, high
.def COSprvL= r6      ; previous cosinus in delta loop, low

;====== step 3 ======
.def SIN2_2H= r13     ; sinus step 2 for divMode=1 [/2], high
.def SIN2_2L= r12     ; sinus step 2 for divMode=1 [/2], low

.def SIN2_4H= r13     ; sinus step 2 for divMode=2 [/4], high
.def SIN2_4L= r12     ; sinus step 2 for divMode=2 [/4], low
.def SIN3_4H= r11     ; sinus step 3 for divMode=2 [/4], high
.def SIN3_4L= r10     ; sinus step 3 for divMode=2 [/4], low
.def SIN4_4H= r9      ; sinus step 4 for divMode=2 [/4], high
.def SIN4_4L= r8      ; sinus step 4 for divMode=2 [/4], low

; r1 & r0 for MUL and others

.equ REGstr = 1
.equ REGend = 25                ; for loop to clear registers

;======================
; *** PROGRAM flags ***
;======================


;========================================================================

    .org 0x0000

; ATmega32A
; MCUCSR: * , * , * , * ,WDRF ,BORF ,EXTRF ,PORF
    JMP   RESET      ; Reset Handler

    JMP  EXT_INT0    ; IRQ0 Handler
    JMP  EXT_INT1    ; IRQ1 Handler
    JMP  EXT_INT2    ; IRQ2 Handler [32]
    JMP  TIM2_COMP   ; Timer2 Compare Handler
    JMP  TIM2_OVF    ; Timer2 Overflow Handler
    JMP  TIM1_CAPT   ; Timer1 Capture Handler
    JMP  TIM1_COMPA  ; Timer1 CompareA Handler
    JMP  TIM1_COMPB  ; Timer1 CompareB Handler
    JMP  TIM1_OVF    ; Timer1 Overflow Handler
    JMP  TIM0_COMP   ; Timer0 Compare Match Handler [32]
    JMP  TIM0_OVF    ; Timer0 Overflow Handler
    JMP  SPI_STC     ; SPI Transfer Complete Handler
    JMP  USART_RXC   ; USART RX Complete Handler
    JMP  USART_UDRE  ; UDR Empty Handler
    JMP  USART_TXC   ; USART TX Complete Handler
    JMP  ADC_RDY     ; ADC Conversion Complete Handler
    JMP  EE_RDY      ; EEPROM Ready Handler
    JMP  ANA_COMP    ; Analog Comparator Handler
    JMP  TWSI        ; Two-wire Serial Interface Handler
    JMP  SPM_RDY     ; Store Program Memory Ready Handler

;---------------------
; 16 bytes Name & City
;---------------------

SIGNAT0:
   .db "AUTOLIGHT-ALEPPO"

SIGNAT1:
   .db  0x00, HEX_year, HEX_month, HEX_day ; number of bytes should be even
SIGNAT2:
   .db  sourceP
   .db  sourceB

   .db  __DATE__
   .db  __TIME__

;=============================
; *RI* Interrupts Handlers ***
;=============================

; IRQ0: PD2, pin4 [MCUCR ,GICR ,GIFR]
EXT_INT0:
    RETI

; IRQ1: PD3, pin5 [MCUCR ,GICR ,GIFR]
EXT_INT1:
    RETI

; IRQ2: PB2, pin3 [MCUCR ,GICR ,GIFR]
EXT_INT2:
    RETI

; Timer2 Compare: [TCCR2 ,ASSR ,TCNT2 ,OCR2 ,TIMSK ,TIFR]
TIM2_COMP:
    RETI

; Timer2 Overflow: [TCCR2 ,ASSR ,TCNT2 ,OCR2 ,TIMSK ,TIFR]
TIM2_OVF:
    RETI

; Timer1 Capture: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_CAPT:
    RETI

; Timer1 CompareA: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_COMPA:
    RETI

; Timer1 CompareB: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_COMPB:
    RETI

; Timer1 Overflow: [TCNT1H/L,TIMSK ,TIFR]
TIM1_OVF:
    RETI

; Timer0 Compare: ??? [TCCR0,TCNT0,OCR0,TIMSK ,TIFR]
TIM0_COMP:
    RETI

; Timer0 Overflow: [TCCR0 ,TCNT0]
TIM0_OVF:
    RETI

; SPI Transfer Complete: [SPCR ,SPSR ,SPDR]
SPI_STC:
    RETI

; USART: RX Complete: [UDR ,UBRRL ,UCSRA ,UCSRB]
USART_RXC:
    RETI

; USART: UDR Empty: [UDR ,UBRRL ,UCSRA ,UCSRB]
USART_UDRE:
    RETI

; USART: TX Complete: [UDR ,UBRRL ,UCSRA ,UCSRB]
USART_TXC:
    RETI

; ADC Conversion Complete: [ADCH/L,ADMUX ,ADCSRA]
ADC_RDY:            ;
    RETI

; EEPROM Ready: [EEARH/L,EEDR ,EECR]
EE_RDY:
    RETI

; Analog Comparator: [SFIOR ,ACSR]
ANA_COMP:
    RETI

; Two-wire Serial Interface: [TWAR ,TWDR ,TWBR ,TWCR ,TWSR]
TWSI:
    RETI

; Store Program Memory Ready: [SPMCR]
SPM_RDY:
    RETI

;===================
; *** MAIN entry ***
;===================

RESET:
; SPH\L [Stack Pointer] = RAMEND [top of SRAM, 0x045F]
    LDI   r16, high(RAMEND)
    OUT   SPH, r16
    LDI   r16,  low(RAMEND)
    OUT   SPL, r16

; DDRA=DDRAini0
    LDI   r16, DDRAini0
    OUT   DDRA, r16
; PORTA=PRTAini0
    LDI   r16, PRTAini0
    OUT   PORTA, r16

; DDRB=DDRBini0
    LDI   r16, DDRBini0
    OUT   DDRB, r16
; PORTB=PRTBini0
    LDI   r16, PRTBini0
    OUT   PORTB, r16

; DDRC=DDRCini0
    LDI   r16, DDRCini0
    OUT   DDRC, r16
; PORTC=PRTCini0
    LDI   r16, PRTCini0
    OUT   PORTC, r16

; DDRD=DDRDini0
    LDI   r16, DDRDini0
    OUT   DDRD, r16
; PORTD=PRTDini0
    LDI   r16, PRTDini0
    OUT   PORTD, r16

; Wait for stable Vcc (the fuse BODEN should be enabled)
    IN    r16, MCUCSR           ; MCU Control and Status Register
    SBRS  r16, BORF             ; Test Brown-out Reset Flag
    RJMP  RST_cnt               ; Continue if 0

    CLR   r16                   ; Brown-out Reset Flag is 1
    OUT   MCUCSR, r16           ; Clear all flags
    RJMP  RESET                 ;  and reboot

;====================================================================
;====================================================================

; clear low and high registers
;-----------------------------

RST_cnt:
    CLR   r0
    LDI   XH, high(REGstr)
    LDI   XL,  low(REGstr)      ; start of variables in low registers
CLR_lp1:
    ST    X+, r0
    CPI   XL, REGend+1          ; end of variables in high registers
    BREQ  CLRend1

    RJMP  CLR_lp1

CLRend1:

; clear extended static RAM registers
;-----------------------------

    LDI   XH, high(SRAMstr)
    LDI   XL,  low(SRAMstr)     ; 0x60
CLR_lp2:
    ST    X+, r0
    CPI   XH, high(RAMEND+1)    ; 0x04 , RAMEND+1 = 0x0460
    BRLO  CLR_lp2
    CPI   XL,  low(RAMEND+1)    ; 0x60
    BRLO  CLR_lp2

CLRend2:

;==========================================
; ============ init variables =============
;==========================================

; 1 sec boot delay
;    RCALL DLYqSec
;    RCALL DLYqSec
;    RCALL DLYqSec
;    RCALL DLYqSec

    CLR   zero                  ; r15

    RJMP  NXTfreq

;===================
; *F* Reset SRAM ***
;===================

RPTtest:
; calc start, set busy LED
    SBI   busyOut               ; LED at pin37 on

; clear the delta bit stream table in SRAM [DLT_tbl: 388 bytes]
    LDI   XL,  low(DLT_tbl)     ; 0x06B8, size 388 bytes
CLR_tbl:
    ST    X+, zero

    CPI   XH, high(0x083C)      ; start of stack pointer buffer
    BRLO  CLR_tbl               ; stack size for 18 calls

    CPI   XL,  low(0x083C)
    BRLO  CLR_tbl

;====================================
;====== preparation for step 1 ======
;====================================
;  in reg: FindexH\L, bandIdx, Nbits_H\L
; out reg: sin0H\L, cos0H\L, NangleH\L
;  const: FidxBnd [97], Cos0Min [16349]
;  table: SinCos0:

; find the index for the table SinCos0:
; index = FindexH\L for band_0, band_1 and band_2
; index = FindexH\L - FidxBnd [97]   for band_3
; index = FindexH\L-2*FidxBnd [2*97] for band_4

    LDS   r18, FindexL
    LDS   r19, FindexH

    LDS   r20, bandIdx
    CPI   r20, 3                ; r20 = bandIdx
    BRLO  SKPmd34

    BREQ  DOmod_3

DOmod_4:
; in band_4, step angle is inreased 4 times [see SRAM5]
    SUBI  r18,  low(FidxBnd)    ; -97
    SBCI  r19, high(FidxBnd)

DOmod_3:
; in band_3, step angle is inreased 2 times [see SRAM5]
    SUBI  r18,  low(FidxBnd)    ; -97
    SBCI  r19, high(FidxBnd)

SKPmd34:
; read cos0_diff and sin0H\L from table SinCos0:
    LDI   ZH, high(SinCos0*2)   ; start at 0x??00

;r19:r18 = Nbits_H\L
    LSL   r18
    ROL   r19
    MOV   ZL, r18
    ADD   ZH, r19
;ZH:ZL = 2*r19"r18 = 2*index

; first, read sin0L from table SinCos0:
    LPM   sin0L, Z+             ; r12, low  byte

; then, read cos0_diff and sin0H from table SinCos0:
    LPM   cos0H, Z              ; r11, high byte

; extract sin0H and cos0H [of diff cos0H\L]
; y1 = cos0_diff*8*256 + sin0H\L [if bandIdx = 0)
; y2 = cos0_diff*4*256 + sin0H\L [if bandIdx > 0)
; r20= bandIdx
    TST   r20
    BRNE  cosSin2

; it is band_0
cosSin1:
    MOV   r22, cos0H ; r11
    ANDI  r22, 0b00000111
    MOV   sin0H, r22 ; r13
; sin0H\L ready

    MOV   r22, cos0H ; r11
    ANDI  r22, 0b11111000
    LSR   r22
    LSR   r22
    LSR   r22
; r22= cos0_diff

    RJMP  cosSinE

;===

; it is band_1, band_2, band_3 or band_4
cosSin2:
    MOV   r22, cos0H ; r11
    ANDI  r22, 0b00000011
    MOV   sin0H, r22 ; r13
; sin0H\L ready

    MOV   r22, cos0H ; r11
    ANDI  r22, 0b11111100
    LSR   r22
    LSR   r22
; r22= cos0_diff

cosSinE:
    LDI   r16,  low(Cos0Min)
    LDI   r17, high(Cos0Min)
    ADD   r16, r22
    ADC   r17, zero
    MOV   cos0L, r16 ; r10
    MOV   cos0H, r17 ; r11
; cos0H\L ready [and sin0H\L]

;=============================================
; find NangleH\L from Nbits_H\L for every band
;=============================================
; NangleH\L = Nbits_H\L /  1 for band_0 and band_1
; NangleH\L = Nbits_H\L /  2 for band_2
; NangleH\L = Nbits_H\L /  8 for band_3
; NangleH\L = Nbits_H\L / 16 for band_4

; D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest\
;    lastDelta5.xlsx , "SRAM5"

    LDS   r18, Nbits_L          ; low  byte
    LDS   r19, Nbits_H          ; high byte

; r20= bandIdx
    CPI   r20, 2
    BRSH  ISbnd_2

DO_div1:
; band_0 or band_1
    RJMP  DO_div_

;===

ISbnd_2:
    CPI   r20, 2
    BRNE  ISbnd_3

DO_div2:
; band_2 , /2
    LSR   r19
    ROR   r18
    RJMP  DO_div_

;===

ISbnd_3:
    CPI   r20, 3
    BRNE  DOdiv16

DO_div8:
; band_3 , /8
    LSR   r19
    ROR   r18

DO_div4:
    LSR   r19
    ROR   r18
    RJMP  DO_div2

;===

DOdiv16:
; band_4 , /16 , okay
    LSR   r19
    ROR   r18
    LSR   r19
    ROR   r18
    RJMP  DO_div4

;===

DO_div_:
    STS   NangleL, r18          ; low  byte
    STS   NangleH, r19          ; high byte, <B0> <B1>
; NangleH\L = Nbits_H\L / 1 or 2 or 8 or 16

;==============================================================
;====== step_1 of band_0, band_1, band_2, band_3, band_4 ======
;==============================================================
;  SRAM: SINpFw1_4:, COSpFw1_4:
; const: Soffset [2615=32768], COSpeak [2^14=16384]
;  in reg: NangleH\L
; out reg: SINprvH\L, COSprvH\L, Nloop_H\L

; create sin(n) & cos(n) in SRAM for n= 0 to NangleH\L [Nbits_H\L / x]
; Band_3: equivalent from 0 to 90 degrees
; Band_4: equivalent from 0 to 90 degrees

BND0_S1:
; sin0H\L and cos0H\L are of the step angle in generating the sinewave
; prepare registers for sin(n) & cos(n) loop, starting with sin(0) & cos(0)

; ZH:ZL [destination of sin(n) at 0x00A8, max 776 bytes]
    LDI   ZH, high(SINpFw1_4)
    LDI   ZL,  low(SINpFw1_4)

; YH:YL [destination of cos(n) at 0x03B0, max 776 bytes]
    LDI   YH, high(COSpFw1_4)
    LDI   YL,  low(COSpFw1_4)

; Note: Soffset [sine/cosine offset] = 2^16/2 = 2^15
; Note: COSpeak [same for SINpeak]   = 2^16/4 = 2^14

;init SINprvH\L= sin(0) = V_fdb_H\L = 0 + Soffset = 2^15
    LDI   r18,  low(Soffset)
    STS   V_fdb_L, r18
    MOV   SINprvL, r18 ; r8
    LDI   r19, high(Soffset)
    STS   V_fdb_H, r19
    MOV   SINprvH, r19 ; r9

; save sin(0) in SRAM table SINpFw1_4
    ST    Z+, r18
    ST    Z+, r19

; init COSprvH\L= cos(0) = COSpeak + Soffset = 2^14 + 2^15
    LDI   r18,  low(COSpeak + Soffset)
    MOV   COSprvL, r18 ; r6
    LDI   r19, high(COSpeak + Soffset)
    MOV   COSprvH, r19 ; r7

; save cos(0) in SRAM table COSpFw1_4
    ST    Y+, r18
    ST    Y+, r19

;===

;init Nloop_H\L= NangleH\L
    LDS   r16, NangleL
    LDS   r17, NangleH
;    SUBI  r16,  low(1)         ; first entry done already
;    SBCI  r17, high(1)
    STS   Nloop_L, r16
    STS   Nloop_H, r17          ; <B0> <B1>

;======================
;=== loop of step_1 ===
;======================

DO1loop:

;--------------------------------------------------------------------------
; SINnewH\L=[(SINprvH\L-2^15)*cos0H\L+(COSprvH\L-2^15)*sin0H\L]/2^14 + 2^15
;--------------------------------------------------------------------------
;  in reg: SINprvH\L, cos0H\L, COSprvH\L, sin0H\L
; out reg: SINnewH\L
;   const: Soffset
;   RCALL: M16_16s

    MOVW  r16, SINprvL          ;1, r9:r8
; r17:r16 = SINprvH\L

    SUBI  r16,  low(Soffset)    ;1
    SBCI  r17, high(Soffset)    ;1
; r17:r16 = SINprvH\L - Soffset = SINprvH\L - 2^15
; r17:r16 = algebric(SINprvH\L)

    MOVW  r26, cos0L            ;1, r10
; r27:r26 = cos0H\L [cosinus of delta step]

; r17:r16 * r27:r26
    RCALL M16_16s
; r21,r20,r19,r18 = (SINprvH\L - 2^15)*cos0H\L

    MOV   r4, r18               ;1
    MOV   r5, r19               ;1
    MOV   SINnewL, r20          ;1, r24
    MOV   SINnewH, r21          ;1, r25
; SINnewH\L,r5:r4 = (SINprvH\L - 2^15)*cos0H\L

;===

    MOVW  r16, COSprvL          ;1, r7:r6
; r17:r16 = COSprvH\L

    SUBI  r16,  low(Soffset)    ;1
    SBCI  r17, high(Soffset)    ;1
; r17:r16 = COSprvH\L - Soffset = COSprvH\L - 2^15

    MOVW  r26, sin0L            ;1, r12
; r27:r26 = sin0H\L [sinus of delta step]

; to multiply: r17:r16 * r27:r26
    RCALL M16_16s
; r21,r20,r19,r18 = (COSprvH\L - 2^15)*sin0H\L

    ADD   r4, r18               ;1
    ADC   r5, r19               ;1
    ADC   SINnewL, r20          ;1, r24
    ADC   SINnewH, r21          ;1, r25
; SINnewH\L,r5:r4 = SINnewH\L,r5:r4 + (COSprvH\L - 2^15)*sin0H\L

    LSL   r5
    ROL   SINnewL               ; r24
    ROL   SINnewH               ; r25
    LSL   r5
    ROL   SINnewL               ; r24
    ROL   SINnewH               ; r25
; /2^14 [*4/256/256]
; SINnewH\L,r5 = SINnewH\L,r5 * 4 / 256 / 256

; for rounding SINnewH\L
    LSL   r5
    BRCC  STP1_C1

    SUBI  SINnewL,  low(-1)     ; r24
    SBCI  SINnewH, high(-1)     ; r25
; SINnewH\L rounded

STP1_C1:
    SUBI  SINnewL,  low(-Soffset) ; r24
    SBCI  SINnewH, high(-Soffset) ; r25
; SINnewH\L=[(SINprvH\L-2^15)*cos0H\L+(COSprvH\L-2^15)*sin0H\L]/2^14 + 2^15
;==========================================================================

;--------------------------------------------------------------------------
; COSnewH\L=[(COSprvH\L-2^15)*cos0H\L-(SINprvH\L-2^15)*sin0H\L]/2^14 + 2^15
;--------------------------------------------------------------------------
;  in reg: SINprvH\L, cos0H\L, COSprvH\L, sin0H\L
; out reg: COSnewH\L
;   const: Soffset
;   RCALL: M16_16s

    MOVW  r16, COSprvL          ;1, r7:r6
; r17:r16 = COSprvH\L

    SUBI  r16,  low(Soffset)    ;1
    SBCI  r17, high(Soffset)    ;1
; r17:r16 = COSprvH\L - Soffset = COSprvH\L - 2^15

    MOVW  r26, cos0L            ;1, r10
; r27:r26 = cos0H\L [cosinus of delta step]

; to multiply: r17:r16 * r27:r26
    RCALL M16_16s
; r21,r20,r19,r18 = (COSprvH\L - 2^15)*cos0H\L

    MOV   r4, r18               ;1
    MOV   r5, r19               ;1
    MOV   COSnewL, r20          ;1, r22
    MOV   COSnewH, r21          ;1, r23
; COSnewH\L,r5:r4 = (COSprvH\L - 2^15)*cos0H\L

;===

    MOVW  r16, SINprvL          ;1, r9:r8
; r17:r16 = SINprvH\L

    SUBI  r16,  low(Soffset)    ;1
    SBCI  r17, high(Soffset)    ;1
; r17:r16 = SINprvH\L - Soffset = SINprvH\L - 2^15

    MOVW  r26, sin0L            ;1, r12
; r27:r26 = sin0H\L [sinus of delta step]

; to multiply: r17:r16 * r27:r26
    RCALL M16_16s
; r21,r20,r19,r18 = (SINprvH\L - 2^15)*sin0H\L

    SUB   r4, r18               ;1
    SBC   r5, r19               ;1
    SBC   COSnewL, r20          ;1, r22
    SBC   COSnewH, r21          ;1, r23
; COSnewH\L,r5:r4 = COSnewH\L,r5:r4 - (SINprvH\L - 2^15)*sin0H\L

    LSL   r5
    ROL   COSnewL ; r22
    ROL   COSnewH ; r23
    LSL   r5
    ROL   COSnewL ; r22
    ROL   COSnewH ; r23
; COSnewH\L,r5 = COSnewH\L,r5 * 4 / 256 / 256

; for rounding COSnewH\L
    LSL   r5
    BRCC  STP1_C2

    SUBI  COSnewL,  low(-1) ; r22
    SBCI  COSnewH, high(-1) ; r23
; COSnewH\L rounded

STP1_C2:
    SUBI  COSnewL,  low(-Soffset) ; r22
    SBCI  COSnewH, high(-Soffset) ; r23
; COSnewH\L=[(COSprvH\L-2^15)*cos0H\L-(SINprvH\L-2^15)*sin0H\L]/2^14+2^15
;==========================================================================

;    LDS   r18, Nloop_L

; save SINnewH\L and COSnewH\L in their SRAM tables
    ST    Z+, SINnewL           ;2, r24
    ST    Z+, SINnewH           ;2, r25
    ST    Y+, COSnewL           ;2, r22
    ST    Y+, COSnewH           ;2, r23

; save SINnewH\L and COSnewH\L in SINprvH\L and COSprvH\L
    MOV   SINprvL, SINnewL      ;1, r8, r24
    MOV   SINprvH, SINnewH      ;1, r9, r25
    MOV   COSprvL, COSnewL      ;1, r6, r22
    MOV   COSprvH, COSnewH      ;1, r7, r23

;===

STP1_C3:
; check if step_1 loop is ended
    RCALL NEXTbit
    BREQ  LOOP1_E

    RJMP  DO1loop

;=== === ===

NEXTbit:
    LDS   r18, Nloop_L
    LDS   r19, Nloop_H
    SUBI  r18,  low(1)
    SBCI  r19, high(1)
    STS   Nloop_L, r18
    STS   Nloop_H, r19
    RET

;=== === ===

LOOP1_E:

; if bandIdx=0 or 1, step_1 done, goto DOdelta: [360 deg stream]
; if bandIdx=2, goto step_2, band_2 [DOdelta:, 180 deg then backward]
; if bandIdx=3, goto BND3_S2
; if bandIdx=4, goto BND4_S2

    LDS   r20, bandIdx

IS_BND4:
    CPI   r20, 4 ; <B0> <B1>
    BRNE  IS_bnd3

; bandIdx=4
    RJMP  BND4_S2

IS_bnd3:
    CPI   r20, 3
    BRNE  IS_bnd2

; bandIdx=3
    RJMP  BND3_S2

IS_bnd2:
    CPI   r20, 2
    BRNE  DO_dlta

; bandIdx=2
    RJMP  BND2_S2

DO_dlta:
; bandIdx=0 or 1
    RJMP  DOdelta

;===========================
;====== step_2 band_4 ======
;===========================
; copy sin(n) of Q1 to Q2 backwards
; then copy sin(n) of Q1 and Q2 to Q3 and Q4 forwards, inverted

BND3_S2:
BND4_S2:
; prepare registers for the loop of Q2
; Nloop_H\L = NangleH\L [Nbits_H\L / 16] - 1
    LDS   r16, NangleL
    LDS   r17, NangleH
    SUBI  r16,  low(1)
    SBCI  r17, high(1)
    STS   Nloop_L, r16
    STS   Nloop_H, r17          ; <breakpoint>

; YH:YL [destination, end of previous sine(n) address]
    MOV   YL, ZL
    MOV   YH, ZH

; ZH:ZL [source, end of previous sine(n) address - 2]
    SUBI  ZL,  low(2)
    SBCI  ZH, high(2)

;----------------------------------------
;=== loop of step_2, band_4 or band_3 ===
;----------------------------------------

; copy sin(n) of Q1 to Q2 backwards
DO_lp42:
; read backward sin(n)
    LD    r21, -Z
    LD    r20, -Z

; save backward sin(n)
    ST    Y+, r20
    ST    Y+, r21

; check if step_2 of band_3 or band_4 is ended
    RCALL NEXTbit
    BRNE  DO_lp42

    LDS   r20, bandIdx
    CPI   r20, 3                ; <breakpoint>
    BREQ  STEP_33

; the entry 0x8000 is added for DL4bits:
    LDI   r20,  low(Soffset)
    LDI   r21, high(Soffset)
    ST    Y+, r20
    ST    Y+, r21

    RJMP  DOdelta

;===

STEP_33:
; prepare registers for the loop of Q3 and Q4
; Nloop_H\L = Nbits_H\L / 2 / 2
    LDS   r16, Nbits_L
    LDS   r17, Nbits_H
    LSR   r17
    ROR   r16
    LSR   r17
    ROR   r16
    STS   Nloop_L, r16
    STS   Nloop_H, r17          ; <breakpoint>

; ZH:ZL [destination of sin(n) at 0x00A8, max 776 bytes]
    LDI   ZH, high(SINpFw1_4)
    LDI   ZL,  low(SINpFw1_4)

; copy sin(n) of Q1 and Q2 to Q3 and Q4 forwards, inverted
DO_lp33:
; read forwards sin(n)
    LD    r20, Z+
    LD    r21, Z+

; invert
    COM   r20
    COM   r21
    SUBI  r20,  low(-1)
    SBCI  r21, high(-1)

; save backward sin(n)
    ST    Y+, r20
    ST    Y+, r21

; check if step_1 band_2 loop is ended
    RCALL NEXTbit
    BRNE  DO_lp33

; the entry 0x8000 is added for DL4bits:
    LDI   r20,  low(Soffset)
    LDI   r21, high(Soffset)
    ST    Y+, r20
    ST    Y+, r21

    RJMP  DOdelta               ; <breakpoint>

;===========================
;====== step_2 band_2 ======
;===========================

; copy sin(n) of Q1+Q2 forwards with negate for Q3+Q4

BND2_S2:
; prepare registers for the loop of Q3+Q4
; Nloop_H\L = NangleH\L [Nbits_H\L / 2]
    LDS   r16, NangleL
    LDS   r17, NangleH
    STS   Nloop_L, r16
    STS   Nloop_H, r17

; YH:YL [destination, end of previous sine(n) address]
    MOV   YL, ZL
    MOV   YH, ZH

; ZH:ZL [source, end of previous sine(n) address - 2]
    SUBI  ZL,  low(2)
    SBCI  ZH, high(2)

;----------------------------------------
;=== loop of step_2, band_2 or band_3 ===
;----------------------------------------

DO_lp32:
DO_lp22:
; read backward sin(n)
    LD    r21, -Z
    LD    r20, -Z

; negate the backward sin(n)
    COM   r20
    COM   r21
    SUBI  r20,  low(-1)
    SBCI  r21, high(-1)

; save backward sin(n)
    ST    Y+, r20
    ST    Y+, r21

; check if step_1 band_2 loop is ended
    RCALL NEXTbit
    BRNE  DO_lp22

;==================

S43_end:
S42_end:
S22_end:
; prepare NangleH\L = NangleH\L * 2 for step_3 band_2
    LDS   r16, NangleL
    LDS   r17, NangleH
    LSL   r16
    ROL   r17
    STS   NangleL, r16
    STS   NangleH, r17

;==================================================
;====== step_2 of band_0 or band_1 ================
;====== step_3 of band_2 or band_3 or band_4 ======
;==================================================
;
; find/save delta bit stream in SRAM, Nbits_H\L

DOdelta:
    LDS   r16, dvFd_L
    LDS   r17, dvFd_H

; save dvFd_pH\L
    STS   dvFd_pL, r16          ; positive delta step
    STS   dvFd_pH, r17

; negate dvFd_pH\L
    COM   r16
    COM   r17
    SUBI  r16,  low(-1)
    SBCI  r17, high(-1)

; save dvFd_nH\L
    STS   dvfd_nL, r16          ; negative delta step
    STS   dvfd_nH, r17

;==========================================

; YH:YL [source of sin(n) at 0x00A8, max 776 bytes]
    LDI   YH, high(SINpFw1_4)
    LDI   YL,  low(SINpFw1_4)

; ZH:ZL [destination of bit stream at 0x06B8, max 388 bytes]
    LDI   ZH, high(DLT_tbl)
    LDI   ZL,  low(DLT_tbl)

; if bandIdx=0, 1 or 2, goto band_0 mode [BD0mode:]
; if bandIdx=3, goto band_3 mode [BD3modC:]
; if bandIdx=4, goto band_4 mode [BD4modC:], okay
    LDS   r16, bandIdx
    CPI   r16, 4
    BRNE  IS_mod3

;bandIdx=4
    RJMP  BD4modC

IS_mod3:
    CPI   r16, 3
    BRNE  BD_modC

;bandIdx=3
    RJMP  BD3modC

BD_modC:
;bandIdx= 0, 1 or 2
    RJMP  BD0mode

;=== ===
;=== ===

BD3modC:
; init delta bits in PLSbyte
    CLR   PLSbyte ; r14

; only half cycle
    LDS   r16, Nbits_L
    LDS   r17, Nbits_H
    LSR   r17
    ROR   r16
    STS   Nloop_L, r16
    STS   Nloop_H, r17          ; <breakpoint>

; assume the starting bit is 0
    CLR   r4

    LDI   XL, 8
    RCALL DL2bits

    RJMP  CHK_sum               ; <BPwave>

;=== === ===
;=== === ===

BD4modC:
; init delta bits in PLSbyte
    CLR   PLSbyte ; r14

; only half cycle
    LDS   r16, Nbits_L
    LDS   r17, Nbits_H
    LSR   r17
    ROR   r16
    LSR   r17
    ROR   r16
    LSR   r17
    ROR   r16

    STS   Nloop_L, r16
    STS   Nloop_H, r17          ; <breakpoint>

    LDI   XL, 8
    RCALL DL4bits

BD34mod:
; complete delta bit stream of 3Q and 4Q in SRAM
; source:      DLT_tbl: at 0x06B8
; destination: DLT_tbl: + Nbits_HL/8/2
; Nloop_H\L = Nbits_HL/8/2

; YH:YL source
    LDI   YH, high(DLT_tbl)
    LDI   YL,  low(DLT_tbl)

; Nloop_H\L = Nbits_HL/8/2
    LDS   r18, Nbits_L
    LDS   r19, Nbits_H
    LSR   r19
    ROR   r18
    LSR   r19
    ROR   r18
    LSR   r19
    ROR   r18

    LSR   r19
    ROR   r18
    STS   Nloop_L, r18
    STS   Nloop_H, r19          ; <breakpoint>

; destination: ZH:ZL = DLT_tbl: + Nbits_HL/8/2 = DLT_tbl: + Nloop_H\L
    ADD   r18, YL
    ADC   r19, YH

    MOV   ZL, r18
    MOV   ZH, r19

BND4lp0:
    LD    r18, Y+
    COM   r18
    ST    Z+, r18

    RCALL NEXTbit
    BRNE  BND4lp0

    RJMP  CHK_sum               ; <BPwave>

;=== === ===
;=== === ===

;bandIdx=0, 1 or 2
BD0mode:
; NangleH\L = Nbits_H/L / 1
    LDS   r17, NangleH
    LDS   r16, NangleL
    SBRS  r16, 0
    RJMP  BITeven

; *2, NangleH is odd, generate 2 cycles
    LSL   r16
    ROL   r17
    SET

BITeven:
    STS   NangleH, r17
    STS   NangleL, r16
    MOV   XL, r16
    ANDI  XL, 0b00000111
    TST   XL
    BRNE  BD0modX

BD0mod8:
; 8 samples/bits for each step
    LDI   XL, 8

    LDS   r16, NangleL
    LDS   r17, NangleH
    STS   Nloop_L, r16
    STS   Nloop_H, r17
; Nloop_H\L = NangleH\L = Nbits_H/L / 1

BD0modC:
; init delta bits in PLSbyte
    CLR   PLSbyte ; r14

BD0modD:
    RCALL DLTbits
    RJMP  CHK_sum ; <B0> <B1> <BPwave>

;=== ===

BD0modX:
    MOV   r4, XL
    LDI   XH, 8
    SUB   XH, XL
; extra shifts for the first extra byte [BD0modC]

; XL = number of delta bits of the first byte
; XH = number of remaing bits to fill the first byte
    RCALL DLTbitX

; prepare Nloop_H\L
    LDS   r16, NangleL
    LDS   r17, NangleH
    SUB   r16, r4           ; =XL
    SBCI  r17, 0
    STS   Nloop_L, r16
    STS   Nloop_H, r17

    LDI   XL, 8
    BRTC  BD0modC

;=== ===

; <todo>
; D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest
;    lastDelta4.xlsx , "stream"
BD0modY:
; clear T flag
    CLT

    LDS   r16, Nbits_L
    LDS   r17, Nbits_H
    SUB   r16, r4
    SBCI  r17, 0
    STS   Nloop_L, r16
    STS   Nloop_H, r17

    LDI   XL, 8
    RCALL DLTbits

; source at 0x00A8, 776 bytes [388*2] of sinewave
    LDI   YH, high(SINpFw1_4)
    LDI   YL,  low(SINpFw1_4)

    LDS   r16, Nbits_L
    LDS   r17, Nbits_H
    STS   Nloop_L, r16
    STS   Nloop_H, r17

    RJMP  BD0modD

;=============
;=============

DLTbits:
    LD    SINnewL, Y+ ; r24
    LD    SINnewH, Y+ ; r25
; read sine value

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    LDS   r20, V_fdb_L
    LDS   r21, V_fdb_H
    CP    r20, SINnewL ; r24
    CPC   r21, SINnewH ; r25
    BRNE  DLTbit0

    NOP
;    SEC
; set carry if equal

DLTbit0:
    BRCS  DLTbit1

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DLTbit1:
; first, save carry bit
    ROL   PLSbyte ; r14

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19
    STS   V_fdb_L, r20
    STS   V_fdb_H, r21

    DEC   XL
    BRNE  DLTbit2

    LDI   XL, 8
    ST    Z+, PLSbyte ; r14
    CLR   PLSbyte ; r14

DLTbit2:
    RCALL NEXTbit
    BREQ  DLTbit3

    BRPL  DLTbits

DLTbit3:
    RET

;=============
;=============

DL2bits:
    LD    SINnewL, Y+ ; r24
    LD    SINnewH, Y+ ; r25
; read sine value

; hi-reg
    LD    SINnxtL, Y+ ; r22
    LD    SINnxtH, Y  ; r23

    LD    SINnxtL, -Y ; r22

; SIN2_2H\L = (SINnewH\L + SINnxtH\L)/2
    RCALL SIN2to2

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    LDS   r20, V_fdb_L
    LDS   r21, V_fdb_H
    CP    r20, SINnewL ; r24
    CPC   r21, SINnewH ; r25
    BRNE  DL2bit0

; carry=0, same as previous bit
    SBRC  r4, 0
    SEC

DL2bit0:
    BRCS  DL2bit1

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL2bit1:
; first, save carry bit
    ROL   PLSbyte ; r14

; save last bit
    CLR   r4
    SBRC  PLSbyte, 0 ; r14
    INC   r4

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19

;===

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    CP    r20, SIN2_2L ; r12
    CPC   r21, SIN2_2H ; r13
    BRNE  DL2bit2

; Carry=0, SINnewH\L < V_fdb_H\L
    SBRC  r4, 0
    SEC

DL2bit2:
    BRCS  DL2bit3

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL2bit3:
; first, save carry bit
    ROL   PLSbyte ; r14

; save last bit
    CLR   r4
    SBRC  PLSbyte, 0 ; r14
    INC   r4

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19
    STS   V_fdb_L, r20
    STS   V_fdb_H, r21

    DEC   XL
    DEC   XL
    BRNE  DL2bit4

    LDI   XL, 8
    ST    Z+, PLSbyte ; r14
    CLR   PLSbyte ; r14

DL2bit4:
    RCALL NEXTbit
    BREQ  DL2bit5

    RJMP  DL2bits

DL2bit5:
    RET

DL2bitC:
    RJMP  DL2bits

;=============
;=============

; SINnewH\L [r25:r24], SINnxtH\L [r23:r22], PLSbyte [r14], r21:r18, XL
; r17:r16, SIN3_4H\L [r11:r10], SIN2_4H\L [r13:r12], SIN4_4H\L [r9:r8]
; r26:r16, r13:r8
; available r7:r2
DL4bits:
    LD    SINnewL, Y+ ; r24
    LD    SINnewH, Y+ ; r25
; read sine value

; hi-reg
    LD    SINnxtL, Y+ ; r22
    LD    SINnxtH, Y  ; r23

    LD    SINnxtL, -Y ; r22

; SIN3_4H\L = (SINnewH\L + SINnxtH\L)/2
; SIN2_4H\L = (SINnewH\L + SIN3_4H\L)/2
; SIN4_4H\L = (SIN3_4H\L + SINnxtH\L)/2
    RCALL SIN2to4

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    LDS   r20, V_fdb_L
    LDS   r21, V_fdb_H
    CP    r20, SINnewL ; r24
    CPC   r21, SINnewH ; r25
    BRNE  DL4bit0

;    NOP
    SEC
; set carry if equal

DL4bit0:
    BRCS  DL4bit1

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL4bit1:
; first, save carry bit
    ROL   PLSbyte ; r14

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19

;===

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    CP    r20, SIN2_4L ; r12
    CPC   r21, SIN2_4H ; r13
    BRNE  DL4bit2

;    NOP
    SEC
; set carry if equal

DL4bit2:
    BRCS  DL4bit3

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL4bit3:
; first, save carry bit
    ROL   PLSbyte ; r14

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19

;===

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    CP    r20, SIN3_4L ; r10
    CPC   r21, SIN3_4H ; r11
    BRNE  DL4bit4

;    NOP
    SEC
; set carry if equal

DL4bit4:
    BRCS  DL4bit5

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL4bit5:
; first, save carry bit
    ROL   PLSbyte

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19

;===

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    CP    r20, SIN4_4L ; r8
    CPC   r21, SIN4_4H ; r9
    BRNE  DL4bit6

;    NOP
    SEC
; set carry if equal

DL4bit6:
    BRCS  DL4bit7

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DL4bit7:
; first, save carry bit
    ROL   PLSbyte ; r14

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19

;===

    STS   V_fdb_L, r20
    STS   V_fdb_H, r21

    DEC   XL
    DEC   XL
    DEC   XL
    DEC   XL
    BRNE  DL4bit8

    LDI   XL, 8
    ST    Z+, PLSbyte ; r14
    CLR   PLSbyte ; r14

DL4bit8:
    RCALL NEXTbit
    BREQ  DL4bit9

    BRPL  DL4bitC

DL4bit9:
    RET

DL4bitC:
    RJMP  DL4bits

;=============
;=============

; XL = number of delta bits of the first byte
; XH = number of remaing bits to fill the first byte
DLTbitX:
    LD    SINnewL, Y+ ; r24
    LD    SINnewH, Y+ ; r25
; read sine value

; assume Carry will be 1, SINnewH\L > V_fdb_H\L
    LDS   r18, dvFd_pL
    LDS   r19, dvFd_pH

    LDS   r20, V_fdb_L
    LDS   r21, V_fdb_H
    CP    r20, SINnewL ; r24
    CPC   r21, SINnewH ; r25
    BRNE  DLTbtX0

    NOP
;    SEC
; set carry if equal

DLTbtX0:
    BRCS  DLTbtX1

; Carry=0, SINnewH\L < V_fdb_H\L
    LDS   r18, dvFd_nL
    LDS   r19, dvFd_nH

DLTbtX1:
; first, save carry bit
    ROL   PLSbyte ; r14

; update V_fdb_H\L += SINnewH\L
    ADD   r20, r18
    ADC   r21, r19
    STS   V_fdb_L, r20
    STS   V_fdb_H, r21

    DEC   XL
    BRNE  DLTbitX


DLTbtX3:
    LSL   PLSbyte ; r14

    DEC   XH
    BRNE  DLTbtX3

    ST    Z+, PLSbyte ; r14
    RET

;============================================================
;============================================================

SIN2to2:
; SIN2_2H\L = (SINnewH\L + SINnxtH\L)/2
    MOV   r16, SINnewL ; r24
    MOV   r17, SINnewH ; r25
    SUBI  r16,  low(Soffset)
    SBCI  r17, high(Soffset)

    SUBI  SINnxtL,  low(Soffset) ; r22
    SBCI  SINnxtH, high(Soffset) ; r23

    ADD   r16, SINnxtL ; r22
    ADC   r17, SINnxtH ; r23
    ROR   r17
    ROR   r16
    BRCC  SKIP2_p

; rounding, +1
    SUBI  r16,  low(-1)
    SBCI  r17, high(-1)
SKIP2_p:
    SUBI  r16,  low(-Soffset)
    SBCI  r17, high(-Soffset)

    MOV   SIN2_2L, r16 ; r12
    MOV   SIN2_2H, r17 ; r13

    RET

;=== ===

; r17:r16, SIN3_4H\L [r11:r10], SIN2_4H\L [r15:r12], SIN4_4H\L [r9:r8]
SIN2to4:
; SIN3_4H\L = (SINnewH\L-Soffset + SINnxtH\L-Soffset)/2
    MOV   r16, SINnewL ; r24
    MOV   r17, SINnewH ; r25
    SUBI  r16,  low(Soffset)
    SBCI  r17, high(Soffset)
    MOV   r18, r16
    MOV   r19, r17

    SUBI  SINnxtL,  low(Soffset) ; r22
    SBCI  SINnxtH, high(Soffset) ; r23

    ADD   r16, SINnxtL ; r22
    ADC   r17, SINnxtH ; r23
    ROR   r17
    ROR   r16
    BRCC  SKIP4_1

; rounding, +1
    SUBI  r16,  low(-1)
    SBCI  r17, high(-1)
SKIP4_1:
; no offset
    MOV   SIN3_4L, r16          ; r10, mid entry
    MOV   SIN3_4H, r17          ; r11

; SIN2_4H\L = (SINnewH\L + SIN3_4H\L)/2
;    ADD   r16, SINnewL
;    ADC   r17, SINnewH
; r19:r18= SINnewH\L - Soffset
    ADD   r16, r18
    ADC   r17, r19
    ROR   r17
    ROR   r16
    BRCC  SKIP4_2

; rounding, +1
    SUBI  r16,  low(-1)
    SBCI  r17, high(-1)
SKIP4_2:
    SUBI  r16,  low(-Soffset)
    SBCI  r17, high(-Soffset)
; with offset
    MOV   SIN2_4L, r16          ; r12
    MOV   SIN2_4H, r17          ; r13, lower mid entry

; SIN4_4H\L = (SIN3_4H\L + SINnxtH\L)/2
    MOV   r16, SIN3_4L          ; r10
    MOV   r17, SIN3_4H          ; r11
    ADD   r16, SINnxtL          ; r22
    ADC   r17, SINnxtH          ; r23
    ROR   r17
    ROR   r16
    BRCC  SKIP4_3

; rounding, +1
    SUBI  r16,  low(-1)
    SBCI  r17, high(-1)
SKIP4_3:
    SUBI  r16,  low(-Soffset)
    SBCI  r17, high(-Soffset)

; with offset
    MOV   SIN4_4L, r16          ; r8, upper mid entry
    MOV   SIN4_4H, r17          ; r9

;===

; no offset
    MOV   r16, SIN3_4L ; r10
    MOV   r17, SIN3_4H ; r11

    SUBI  r16,  low(-Soffset)
    SBCI  r17, high(-Soffset)

; with offset
    MOV   SIN3_4L, r16          ; r10, mid entry
    MOV   SIN3_4H, r17          ; r11

    RET

;============================================================
;============================================================

RORnblL:
; input r18, reverse bits order of low nibble with reverse polarity
;                               ;    r19   C     r18
;                               ; 87654321 x xxxxxxxx
    MOV   r19, r18              ; 87654321 x 87654321
    LSR   r19                   ; L8765432 1 87654321
    ROL   r18                   ; L8765432 8 76543211
    LSR   r19                   ; LL876543 2 76543211
    ROL   r18                   ; LL876543 7 65432112
    LSR   r19                   ; LLL87654 3 65432112
    ROL   r18                   ; LLL87654 6 54321123
    LSR   r19                   ; LLLL8765 4 54321123
    ROL   r18                   ; LLLL8765 5 43211234;
    SWAP  r19                   ; 8765LLLL 5 43211234
    ANDI  r18, 0b00001111       ; 8765LLLL 5 LLLL1234
    OR    r18, r19              ; 8  7  6  5  4' 3' 2' 1'
    RET


RORbyte:
; input r18, reverse bits order
;                               ;    r19   C     r18
;                               ; 87654321 x xxxxxxxx
    MOV   r19, r18              ; 87654321 x 87654321
    LSR   r19                   ; L8765432 1 87654321
    ROL   r18                   ; L8765432 8 76543211
    LSR   r19                   ; LL876543 2 76543211
    ROL   r18                   ; LL876543 7 65432112
    LSR   r19                   ; LLL87654 3 65432112
    ROL   r18                   ; LLL87654 6 54321123
    LSR   r19                   ; LLLL8765 4 54321123
    ROL   r18                   ; LLLL8765 5 43211234

    LSR   r19                   ; LLLLL876 5 43211234
    ROL   r18                   ; LLLLL876 4 32112345
    LSR   r19                   ; LLLLLL87 6 32112345
    ROL   r18                   ; LLLLLL87 3 21123456
    LSR   r19                   ; LLLLLLL8 7 21123456
    ROL   r18                   ; LLLLLLL8 2 11234567
    LSR   r19                   ; LLLLLLLL 8 11234567
    ROL   r18                   ; LLLLLLLL 1 12345678
    RET

;========

BITSsum:
; ZH:ZL [source of delta stream]
    LDI   ZH, high(DLT_tbl)
    LDI   ZL,  low(DLT_tbl)

    MOV   YL, zero
    MOV   YH, zero

    LDS   r20, bandIdx
    CPI   r20, 3                ; <breakpoint>
    BRSH  BT34sum

    CPI   r20, 2
    BRNE  ISb1sum

    RJMP  BIT2sum

ISb1sum:
    CPI   r20, 1
    BRNE  BIT0sum

    RJMP  BIT1sum

;=== ===

BIT0sum:
; r19:r18=Nbits_H\L
    SBRS  r18, 0
    RJMP  BIT1sum

; *2
    LSL   r18
    ROL   r19
    RJMP  BIT1sum

;===

BT34sum:
; r19:r18=Nbits_H\L
; /8
    LSR   r19
    ROR   r18
    LSR   r19
    ROR   r18
    LSR   r19
    ROR   r18
    STS   Nloop_L, r18
    STS   Nloop_H, r19

SUM_lp2:
    LDI   r16, 8
    LD    r17, Z+
SUM_lp1:
    ADIW  YL, 1
    LSL   r17
    BRCS  SUMskip

    SUBI  YL,  low(2)
    SBCI  YH, high(2)

SUMskip:
    DEC   r16
    BRNE  SUM_lp1

    RCALL NEXTbit
    BRNE  SUM_lp2

    RET

;===

BIT2sum:
; r19:r18=Nbits_H\L
    SBRS  r18, 2
    RJMP  BT34sum

    LDI   r16, 4
    LD    r17, Z+

SUM2lp0:
    ADIW  YL, 1
    LSL   r17
    BRCS  SM2skp0

    SUBI  YL,  low(2)
    SBCI  YH, high(2)

SM2skp0:
    DEC   r16
    BRNE  SUM2lp0

    RJMP  BT34sum

;===

BIT1sum:
; r19:r18=Nbits_H\L
    MOV   r20, r18
    ANDI  r20, 0b00000111
    TST   r20
    BREQ  BT1sumE

    MOV   r16, r20
    LD    r17, Z+

SUM1lp0:
    ADIW  YL, 1
    LSL   r17
    BRCS  SM1skp0

    SUBI  YL,  low(2)
    SBCI  YH, high(2)

SM1skp0:
    DEC   r16
    BRNE  SUM1lp0

BT1sumE:
    RJMP  BT34sum

;=== ===

CHK_sum:
;    RJMP   DO_wave              ; <BPwave>

; check 1's sum = Nbits_H\L / 8
    LDS   r18, Nbits_L
    LDS   r19, Nbits_H
    RCALL BITSsum               ; <BP> returned from BT34sum

    MOV   r18, YL
    OR    r18, YH
    BREQ  DO_wave
;    BREQ  FFT_sum

    CPI   YH, 0xFF
    BRNE  DO_wave               ; sum not 0 or -1
;    BRNE  NWdvDf_               ; sum not 0 or -1

    CPI   YL, 0xFE
    BRNE  DO_wave               ; sum not 0 ot -1
;    BRNE  NWdvDf_               ; sum not 0 ot -1

    LDS   r18, DLT_tbl          ; byte at 0x06B8
    SBR   r18, 0x80             ; set MSB to 1, to let sum=0 
    STS   DLT_tbl, r18          ; <breakpoint>

DO_wave:
; end of calc, start of wave
    CBI   busyOut               ; <B0>

;================================================
;================================================
;================================================
;================================================

    LDS   r18, lowBand
    TST   r18
    BREQ  DOwavHi

    RJMP  DOwavLo

;===

DOwavHi:

;====== last step ======

; From D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest\
; lastDelta4.xlsx, "DLT4x_3"

; In case N_bits_H\L is not a mutiple of 8, bits are arranged as follows:
; Table first byte has the starting MOD(N_bitsH\L,8) bits only [MSB]
; Table last byte has, therefore, the last 8 bits of the stream
; In this code, MSB of a byte is outputed first
; N.B: if N_bits_H\L is odd, delta stream is for 2 cycles
;
; register 'nextByte' in delta loop, also as temporary register
; frstBytH\L is the first byte address of the table in SRAM
; lastBytH\L is the last byte address of the table + 1 [+1 for loop end]
; DLT_tbl is fixed in SRAM
    LDI   frstBytL,  low(DLT_tbl) ; r16
    LDI   frstBytH, high(DLT_tbl) ; r17

; XH:XL = frstBytH\L
    MOVW  XL, frstBytL ; r27:r26, r17:r16

; PLSbyte = first byte of the table to be outputted
    LD    PLSbyte, X+ ; r14

; temporarily, Nangle_H\L is saved in lastBytH\L
    LDS   lastBytL, Nbits_L   ; r20, =N_bits_H\L if even, 2*N_bits_H\L if odd
    LDS   lastBytH, Nbits_H   ; r21

    SBRS  lastBytL, 0         ; r20
    RJMP  SKIPhi0

    LSL   lastBytL            ; r20
    ROR   lastBytH            ; r21

SKIPhi0:
    MOV   nextByte, lastBytL      ; r22, r20
    ANDI  nextByte, 0b00000111    ; r22, nextByte also used by SEThiLp:
    BREQ  SKIPhi1

    SUBI  lastBytL,  low(-8)      ; r20
    SBCI  lastBytH, high(-8)      ; r21
; MOD(N_bitsH\L,8) != 0, lastBytH\L += (1 byte * 8 bits)

SKIPhi1:
    LSR   lastBytH                ; r21
    ROR   lastBytL                ; r20
    LSR   lastBytH                ; r21
    ROR   lastBytL                ; r20
    LSR   lastBytH                ; r21
    ROR   lastBytL                ; r20
    ADD   lastBytL, frstBytL      ; r20 + r16
    ADC   lastBytH, frstBytH      ; r21 + r17 + carry
; final lastBytH\L [bytes] = lastBytH\L [bits] / 8

; lastBytH\L += 1 [required by the loop end]
    SUBI  lastBytL,  low(-1)      ; r20
    SBCI  lastBytH, high(-1)      ; r21

; The labels of the 8 loops (below) are DLT_lp0: to DLT_lp7:
;    though the even ones are used
; 'SEThiLp:' returns ZH:ZL [the address of the loop label for IJMP]
    RCALL SEThiLp
    IJMP

; Falling edge of LED 'syncOut' signals the end of wave cycle

;===

; DLThLp7: [included though not needed here]
DLThLp7:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

DLThLp6:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

; DLThLp5: not addressed by IJMP
DLThLp5:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

DLThLp4:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

; DLThLp3: not addressed by IJMP
DLThLp3:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

DLThLp2:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

; DLThLp1: not addressed by IJMP
DLThLp1:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LD    nextByte, X+          ;2c, r22
    MOV   PLSbyte, nextByte     ;1c, r14, r22, prepare the next byte for output

DLThLp0:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    LD    nextByte, X+          ;2c, r22, get temporarily the next byte

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit1, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    CP    XH, lastBytH          ;1c, r21, compare lastBytH
    NOP                         ;1c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit2, @PORTB,0
    BRNE  CNThBt3               ;1c/2c
    LSL   PLSbyte               ;1c, r14
    CP    XL, lastBytL          ;1c, r26, r20, compare lastBytL

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit3, @PORTB,0
    BREQ  CNhBt41               ;1c/2c
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c

CNhBt42:                        ; XH != lastBytH | XL != lastBytL
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit4, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    SBIS  nxtF_In               ;1c, PINA,4
    RJMP  NXTfrqL

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit5, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    NOP                         ;1c
    NOP                         ;1c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit6, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    SBI   syncOut               ;2c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit7, @PORTB,0
    MOV   PLSbyte, nextByte     ;1c, r14, r22
    RJMP  DLThLp0               ;2c

;=== ===

NXTfrqH:
    RJMP  NXTfreq

;=== ===

CNThBt3:                        ; XH != lastBytH
    LSL   PLSbyte               ;1c, r14

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit3, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RJMP  CNhBt42               ;2c

;===

CNhBt41:                        ; XL == lastBytL & XH == lastBytH
    LSL   PLSbyte               ;1c, r14

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit4, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    CBI   syncOut               ;2c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit5, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    MOVW  XL, frstBytL          ;1c, r27:r26, r17:r16
    INC   counter               ;1c, r23

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit6, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    LD    nextByte, X+          ;2c, r22

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit7, @PORTB,0
    MOV   PLSbyte, nextByte     ;1c, r14, r22
    IJMP                        ;2c

; The loop can also be interrupted via TWI, for example, to generate another frequency

;=== === ===

; 'SEThiLp' returns ZH:ZL = the address of the loop label for IJMP
SEThiLp:
; nextByte = MOD(Nbits_H\L,8)
    TST   nextByte ; r22
    BRNE  IS_2btH

    LDI   ZL,  low(DLThLp0)
    LDI   ZH, high(DLThLp0)
    RJMP  SETlp_E

IS_2btH:
    CPI   nextByte, 2 ; r22
    BRNE  IS_4btH

    LDI   ZL,  low(DLThLp2)
    LDI   ZH, high(DLThLp2)
    RJMP  SETlp_E

IS_4btH:
    CPI   nextByte, 4 ; r22
    BRNE  IS_6btH

    LDI   ZL,  low(DLThLp4)
    LDI   ZH, high(DLThLp4)
    RJMP  SETlp_E

IS_6btH:
    CPI   nextByte, 6 ; r22
    BRNE  DO_xBtH

    LDI   ZL,  low(DLThLp6)
    LDI   ZH, high(DLThLp6)
    RJMP  SETlp_E

 DO_xBtH:
    POP   ZH
    POP   ZL
    LDI   ZL,  low(TBL_err)
    LDI   ZH, high(TBL_err)
    PUSH  ZL
    PUSH  ZH

SETlp_E:
    RET

;=============================================================
;=============================================================

DOwavLo:
; frstBytH\L is the first byte address of the table in SRAM
; lastBytH\L is the last byte address of the table + 1 [+1 for loop end]
; DLT_tbl is fixed in SRAM
    LDI   frstBytL,  low(DLT_tbl) ; r16
    LDI   frstBytH, high(DLT_tbl) ; r17

; XH:XL = frstBytH\L
    MOVW  XL, frstBytL          ; r27:r26, r17:r16

; PLSbyte = first byte of the table to be outputted
    LD    PLSbyte, X+ ; r14

; temporarily, Nangle_H\L is saved in lastBytH\L
    LDS   lastBytL, Nbits_L     ; r20, =N_bits_H\L if even, 2*N_bits_H\L if odd
    LDS   lastBytH, Nbits_H     ; r21

    SBRS  lastBytL, 0           ; r20
    RJMP  SKIPlo0

    LSL   lastBytL              ; r20
    ROR   lastBytH              ; r21

SKIPlo0:
    MOV   nextByte, lastBytL    ; r22, r20
    ANDI  nextByte, 0b00000111  ; r22, nextByte also used by SETloLp:
    BREQ  SKIPlo1

    SUBI  lastBytL,  low(-8)    ; r20
    SBCI  lastBytH, high(-8)    ; r21
; MOD(N_bitsH\L,8) != 0, lastBytH\L += (1 byte * 8 bits)

SKIPlo1:
    LSR   lastBytH              ; r21
    ROR   lastBytL              ; r20
    LSR   lastBytH              ; r21
    ROR   lastBytL              ; r20
    LSR   lastBytH              ; r21
    ROR   lastBytL              ; r20
    ADD   lastBytL, frstBytL    ; r20 + r16
    ADC   lastBytH, frstBytH    ; r21 + r17 + carry
; final lastBytH\L [bytes] = lastBytH\L [bits] / 8

; lastBytH\L += 1 [required by the loop end]
    SUBI  lastBytL,  low(-1)    ; r20
    SBCI  lastBytH, high(-1)    ; r21

; The labels of the 8 loops (below) are DLTlLp0: to DLTlLp7:
;    though the even ones are used
; 'SETloLp:' returns ZH:ZL [the address of the loop label for IJMP]
    RCALL SETloLp
    IJMP

; Falling edge of LED 'syncOut' signals the end of wave cycle

;===

; DLTlLp7: [included though not needed here]
DLTlLp7:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

DLTlLp6:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

; DLTlLp5: not addressed by IJMP
DLTlLp5:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

DLTlLp4:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

; DLTlLp3: not addressed by IJMP
DLTlLp3:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

DLTlLp2:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c

; DLTlLp1: not addressed by IJMP
DLTlLp1:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0 ?, @PORTB,0
    LD    nextByte, X+          ;2c, r22
    RCALL dly_28c               ;124c
    MOV   PLSbyte, nextByte     ;1c, r14, r122, prepare the next byte for output

DLTlLp0:
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit0, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    LD    nextByte, X+          ;2c, r22, get temporarily the next byte

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit1, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    CP    XH, lastBytH          ;1c, r21, compare lastBytH
    NOP                         ;1c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit2, @PORTB,0
    BRNE  CNTlBt3               ;1c/2c
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    CP    XL, lastBytL          ;1c, r26, r20, compare lastBytL

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit3, @PORTB,0
    BREQ  CNlBt41               ;1c/2c
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c

CNlBt42:                        ; XH != lastBytH | XL != lastBytL
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit4, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    SBIS  nxtF_In               ;1c, PINA,4
    RJMP  NXTfrqL

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit5, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    NOP                         ;1c
    NOP                         ;1c
    
    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit6, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    SBI   syncOut               ;2c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit7, @PORTB,0
    MOV   PLSbyte, nextByte     ;1c, r14, r22
    RCALL dly_28c               ;124c
    RJMP  DLTlLp0               ;2c

;=== ===

NXTfrqL:
    RJMP  NXTfreq

;=== ===

CNTlBt3:                        ; XH != lastBytH
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit3, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    RJMP  CNlBt42               ;2c

;===

CNlBt41:                        ; XL == lastBytL & XH == lastBytH
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit4, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    CBI   syncOut               ;2c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit5, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    MOVW  XL, frstBytL          ;1c, r26, r16
    INC   counter               ;1c, r23

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit6, @PORTB,0
    LSL   PLSbyte               ;1c, r14
    RCALL dly_28c               ;124c
    LD    nextByte, X+          ;2c

    OUT   PORTB, PLSbyte        ;1c, r14, outputs delta bit7, @PORTB,0
    MOV   PLSbyte, nextByte     ;1c, r14, r22
    RCALL dly_28c               ;124c
    IJMP                        ;2c

; The loop can also be interrupted via TWI, for example, to generate another frequency

;=== === ===

; 'SETloLp' returns ZH:ZL = the address of the loop label for IJMP
SETloLp:
; nextByte = MOD(Nbits_H\L,8)
    TST   nextByte ; r22
    BRNE  IS_2btL

    LDI   ZL,  low(DLTlLp0)
    LDI   ZH, high(DLTlLp0)
    RJMP  SETlp_E

IS_2btL:
    CPI   nextByte, 2 ; r22
    BRNE  IS_4btL

    LDI   ZL,  low(DLTlLp2)
    LDI   ZH, high(DLTlLp2)
    RJMP  SETlp_E

IS_4btL:
    CPI   nextByte, 4 ; r22
    BRNE  IS_6btL

    LDI   ZL,  low(DLTlLp4)
    LDI   ZH, high(DLTlLp4)
    RJMP  SETlp_E

IS_6btL:
    CPI   nextByte, 6 ; r22
    BRNE  DO_xBtL

    LDI   ZL,  low(DLTlLp6)
    LDI   ZH, high(DLTlLp6)
    RJMP  SETlp_E

 DO_xBtL:
    POP   ZH
    POP   ZL
    LDI   ZL,  low(TBL_err)
    LDI   ZH, high(TBL_err)
    PUSH  ZL
    PUSH  ZH

    RJMP  SETlp_E

;=== ===

dly_28c:
    LDI   r25, 39               ;1c
dly28Lp:
    DEC   r25                   ;1c
    BRNE  dly28Lp               ;2c

    RET                         ;4, 117+4+3=124c

;=============================================================

TBL_err:
; Do HLTloop [syncOut LED, 8 Hz] to signal internal table error
    LDI   r20, 62
    RJMP  HLTloop
    RJMP  TBL_err

;============================================
; *F* Initial step for the next frequency ***
;============================================
; out reg: indexH\L, FindexH\L, lowBand, bandIdx
;          Nbits_H\L, dvFd_H\L
; out pin: GG_Out?, DDRD [LoBndDDR, HiBndDDR]
;  in pin: freq2In, freq1In
;    RJMP: HLTloop:, RPTtest:
;   table: NbitsTb:, STEPtbl:
;   const: FidxMax, 676, LoBands, LoBndDDR, HiBndDDR

NXTfreq:
    SBIS  nxtF_In
    RJMP  NXTfreq

    IN    r16, freq2In

; r16= hundreds
    ANDI  r16, 0b00001111

; tens & units
    IN    r17, freq1In
    MOV   r18, r17

; r17= tens
    ANDI  r17, 0b11110000
    SWAP  r17

; r18= units 
    ANDI  r18, 0b00001111

; r0= 0 to 90
    LDI   r19, 10
    MUL   r17, r19

; r1:r0= 0 to 99
    ADD   r0, r18
    PUSH  r0

    LDI   r19, 100
    MUL   r16, r19
    POP   r16
; r17:r16= indexH\L
    ADD   r0, r16
    ADC   r1, zero

    MOV   r16, r0
    MOV   r17, r1

    CPI   r16,  low(FidxMax+1)
    LDI   r18, high(FidxMax+1)
    CPC   r17, r18
    BRLO  NXTfrqC

; Do HLTloop [syncOut LED, 2.5 Hz] to signal frequency out of range
    LDI   r20, 200
    RJMP  HLTloop

NXTfrqC:
    STS  indexL, r0
    STS  indexH, r1

; assume indexH\L of hiBands [lowBand=0]
    STS   lowBand, zero

; isolate the 3 capacitors of loBands
;    CBI   GG_Out
    LDI   r19, HiBndDDR

; check if indexH\L < LoBands, indexH\L is of hiBands
    CPI   r16,  low(LoBands)    ; 485
    LDI   r18, high(LoBands)
    CPC   r17, r18
    BRLO  CHCKbnd

; indexH\L is of loBands
    SUBI  r16,  low(LoBands)
    SBCI  r17, high(LoBands)

; signal it is loBands [lowBand=1]
    LDI   r18, 1
    STS   lowBand, r18

; activate the 3 capacitors of loBands
;    SBI   GG_Out
    LDI   r19, LoBndDDR

CHCKbnd:
; update the extra 2 capacitors
    OUT   DDRD, r19

; FindexH\L from 0 to 484
    STS   FindexL, r16
    STS   FindexH, r17

;===

; check FindexH\L is of which band [bandIdx, 0 to 4]
    LDI   r26,  low(676)
    LDI   r27, high(676)

;band [0 to 4] = FindexH\L / 97 = FindexH\L * 676 / 256 / 256

; multiply: r17:r16 * r27:r26
    RCALL MUL_pos
; r21,r20,r19,r18 = result
; r20= bandIdx

    STS   bandIdx, r20          ; bandIdx = 0,1,2,3 or 4

;===

DOnwFrq:
; read Nbits_H\L from table NbitsTb:
    LDI   ZH, high(NbitsTb*2)   ; start at 0x??00

;r17:r16 = FindexH\L [not changed by MUL_pos]
    LSL   r16
    ROL   r17
    MOV   ZL, r16
    ADD   ZH, r17
;ZH:ZL = 2*FindexH\L

; read Nbits_L then Nbits_H
    LPM   r19, Z+               ; low  byte
    LPM   r20, Z+               ; high byte

    STS   Nbits_L, r19          ; low  byte
    STS   Nbits_H, r20          ; high byte

;===

    LDS   r16, FindexL
    LDS   r17, FindexH

; read dvFd_H\L from table STEPtbl:
    LDI   ZH, high(STEPtbl*2)   ; start at 0x??00

;r17:r16 = FindexH\L [not changed by MUL_pos]
    LSL   r16
    ROL   r17
    MOV   ZL, r16
    ADD   ZH, r17
;ZH:ZL = 2*FindexH\L

; read dvFd_L then dvFd_H
    LPM   r19, Z+               ; low  byte
    LPM   r20, Z+               ; high byte

    STS   dvFd_L, r19           ; low  byte
    STS   dvFd_H, r20           ; high byte

    RJMP  RPTtest               ; <B0>

;====================================================
; *F* signal end of hibands [syncOut LED, 2.5 Hz] ***
;====================================================
;  in reg: r20
; out pin: busyOut, syncOut
;   RCALL: DLYmSec:

HLTloop:
    CBI   busyOut

; Flip syncOut LED
    SBIC  syncOut
    RJMP  LEDis1C

    SBI   syncOut
    RJMP  LEDendC

LEDis1C:
    CBI   syncOut
    NOP
LEDendC:
    MOV   r17, r20              ; 2.5 Hz
    RCALL DLYmSec
    RJMP  HLTloop

;==============================================================
;==============================================================
;==============================================================

;===================================================
; Division 24/16, 429 cycles, rounding res_U\H\L ***
;===================================================
; dividend : r18(dd_U), r17(dd_H) , r16(dd_L)
; divisor  : r20(dv_H) , r19(dv_L)
; remainder: r14(rmd_H), r13(rmd_L)
; loopCount: r21(steps)
; result   : r2(res_U),r1(res_H),r0(res_L)
; maximum tested 414 cycles + 15 for rounding

; r2:r1:r0 = r18:r17:r16 / r20:r19 , r14:r13 remainder
; if division 24/8, r20=0

; 12 bytes + SREG (in case PUSH and POP)

D24u16rd:
    CLR   r13
    SUB   r14, r14              ; to clear carry
    LDI   r21, 25
    RJMP  D24u16u1

D24u16u2:
    ROL   r13
    ROL   r14
    SUB   r13, r19
    SBC   r14, r20
    BRCC  D24u16u3

    ROL   r0
    ROL   r1
    ROL   r2
    ADD   r13, r19
    ADC   r14, r20
D24u16u1:
    ROL   r16
    ROL   r17
    ROL   r18
    DEC   r21
    BRNE  D24u16u2

    COM   r0
    COM   r1
    COM   r2

; rounding begin
    LSR   r20
    ROR   r19
    CP    r19, r13
    CPC   r20, r14
    BRSH  D24u16uR              ; if divisor/2 > remainder, skip rounding

    INC   r0                    ; add 1 to resultL
    BRNE  D24u16uR              ; if resultL becomes 0, resultH+1

    INC   r1
    BRNE  D24u16uR              ; if resultH not zero, skip

    INC   r2
    BRNE  D24u16uR              ; if resultU not zero, skip

    DEC   r2
    DEC   r1
    DEC   r0
D24u16uR:
; rounding end
    RET

D24u16u3:
    ROL   r0
    ROL   r1
    ROL   r2
    RJMP  D24u16u1

;-------------------------------------------------------
; *R* multiply 16 bits (pos or neg) by 16 bits (pos) ***
;-------------------------------------------------------
; r17:r16 positive or negative
; r27:r26 positive

M16_16s:
    SBRS  r17, 7
    RJMP  MUL_pos

    SET                         ;1, signal r17:r16 is negative
    COM   r16                   ;1
    COM   r17                   ;1
    SUBI  r16,  low(-1)         ;1
    SBCI  r17, high(-1)         ;1

MUL_pos:
; to multiply: r17:r16 * r27:r26
    MUL   r17, r27              ;2
    MOVW  r21:r20, r1:r0        ;1
    MUL   r16, r26              ;2
    MOVW  r19:r18, r1:r0        ;1
    MUL   r17, r26              ;2
    ADD   r19, r0               ;1
    ADC   r20, r1               ;1
    ADC   r21, zero             ;1 , r15
    MUL   r27, r16              ;2
    ADD   r19, r0               ;1
    ADC   r20, r1               ;1
    ADC   r21, zero             ;1 , r15
; r21,r20,r19,r18 = result

    BRTC  MULposR

    CLT                         ; reset T
    COM   r18                   ; let result be negative
    COM   r19
    COM   r20
    COM   r21
    SUBI  r18,  low(-1)
    SBCI  r19, high(-1)
    SBCI  r20, high(-1)
    SBCI  r21, high(-1)

MULposR:
    RET

;------------------------------------------------
; *R* multiply 16 bits (pos) by 16 bits (pos) ***
;------------------------------------------------
; r21:r18 = r17:r16 * r27:r26
M16_16u:
    MUL   r17, r27              ;2
    MOVW  r21:r20, r1:r0        ;1
    MUL   r16, r26              ;2
    MOVW  r19:r18, r1:r0        ;1
    MUL   r17, r26              ;2
    ADD   r19, r0               ;1
    ADC   r20, r1               ;1
    ADC   r21, zero             ;1 , r15
    MUL   r27, r16              ;2
    ADD   r19, r0               ;1
    ADC   r20, r1               ;1
    ADC   r21, zero             ;1 , r15
    RET

;----------------------------------
;----------------------------------
; *R* Delay, multiple of 1 msec *** 8 MHz
;----------------------------------
;----------------------------------
; r17 = t (ms)
; used and then restored: r16 and r17
; delay= [ (28+3)*256 + (4+3*20) ] * 250 * 0.125 = 250 ms

DLYqSec:                        ;+2c call
    PUSH   r17                  ; 2c, added
    LDI    r17, 250             ; 1c, was 250
    RJMP   DLYsecC              ; 2c, added

DLYmSec:
    PUSH   r17                  ; 2c, added
DLYsecC:
    PUSH   r16                  ; 2c, added
DLYsecL:
    CLR    r16                  ; 1c
DlyM_lp:
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    DEC   r16                   ; 1c
    BRNE  DlyM_lp               ; 2/1c

    LDI   r16, 20               ; 1c
    NOP                         ; 1c, added for timing
INNERlp:
    DEC   r16                   ; 1c
    BRNE  INNERlp               ; 2/1c

    DEC   r17                   ; 1c
    BRNE  DLYsecL               ; 2/1c

    POP   r16                   ; 2c, added
    POP   r17                   ; 2c, added
    RET                         ; 4c

;====================================================================
;====================================================================
;====================================================================

;---------------
; *** Tables ***
;---------------

    .org 0x0800

; Generated by EarTest_08_05.asm, see dvFd_simu.xlsx "Steps"
; Findex from 0 to 484
STEPtbl:
    .dw 1563 ; delta step of Findx =   0
    .dw 1547 ; delta step of Findx =   1
    .dw 1530 ; delta step of Findx =   2
    .dw 1515 ; delta step of Findx =   3
    .dw 1500 ; delta step of Findx =   4
    .dw 1609 ; delta step of Findx =   5
    .dw 1470 ; delta step of Findx =   6
    .dw 1457 ; delta step of Findx =   7
    .dw 1443 ; delta step of Findx =   8
    .dw 1428 ; delta step of Findx =   9
    .dw 1415 ; delta step of Findx =  10
    .dw 1403 ; delta step of Findx =  11
    .dw 1389 ; delta step of Findx =  12
    .dw 1376 ; delta step of Findx =  13
    .dw 1478 ; delta step of Findx =  14
    .dw 1465 ; delta step of Findx =  15
    .dw 1340 ; delta step of Findx =  16
    .dw 1328 ; delta step of Findx =  17
    .dw 1316 ; delta step of Findx =  18
    .dw 1305 ; delta step of Findx =  19
    .dw 1293 ; delta step of Findx =  20
    .dw 1283 ; delta step of Findx =  21
    .dw 1271 ; delta step of Findx =  22
    .dw 1260 ; delta step of Findx =  23
    .dw 1250 ; delta step of Findx =  24
    .dw 1239 ; delta step of Findx =  25
    .dw 1230 ; delta step of Findx =  26
    .dw 1220 ; delta step of Findx =  27
    .dw 1209 ; delta step of Findx =  28
    .dw 1200 ; delta step of Findx =  29
    .dw 1191 ; delta step of Findx =  30
    .dw 1181 ; delta step of Findx =  31
    .dw 1172 ; delta step of Findx =  32
    .dw 1163 ; delta step of Findx =  33
    .dw 1154 ; delta step of Findx =  34
    .dw 1145 ; delta step of Findx =  35
    .dw 1137 ; delta step of Findx =  36
    .dw 1128 ; delta step of Findx =  37
    .dw 1119 ; delta step of Findx =  38
    .dw 1112 ; delta step of Findx =  39
    .dw 1103 ; delta step of Findx =  40
    .dw 1095 ; delta step of Findx =  41
    .dw 1088 ; delta step of Findx =  42
    .dw 1079 ; delta step of Findx =  43
    .dw 1071 ; delta step of Findx =  44
    .dw 1064 ; delta step of Findx =  45
    .dw 1056 ; delta step of Findx =  46
    .dw 1049 ; delta step of Findx =  47
    .dw 1041 ; delta step of Findx =  48
    .dw 1035 ; delta step of Findx =  49
    .dw 1028 ; delta step of Findx =  50
    .dw 1020 ; delta step of Findx =  51
    .dw 1014 ; delta step of Findx =  52
    .dw 1007 ; delta step of Findx =  53
    .dw 1001 ; delta step of Findx =  54
    .dw  993 ; delta step of Findx =  55
    .dw  987 ; delta step of Findx =  56
    .dw  981 ; delta step of Findx =  57
    .dw  974 ; delta step of Findx =  58
    .dw  968 ; delta step of Findx =  59
    .dw  962 ; delta step of Findx =  60
    .dw  956 ; delta step of Findx =  61
    .dw  950 ; delta step of Findx =  62
    .dw  944 ; delta step of Findx =  63
    .dw  938 ; delta step of Findx =  64
    .dw  932 ; delta step of Findx =  65
    .dw  926 ; delta step of Findx =  66
    .dw  920 ; delta step of Findx =  67
    .dw  915 ; delta step of Findx =  68
    .dw  909 ; delta step of Findx =  69
    .dw  903 ; delta step of Findx =  70
    .dw  899 ; delta step of Findx =  71
    .dw  893 ; delta step of Findx =  72
    .dw  888 ; delta step of Findx =  73
    .dw  882 ; delta step of Findx =  74
    .dw  878 ; delta step of Findx =  75
    .dw  872 ; delta step of Findx =  76
    .dw  867 ; delta step of Findx =  77
    .dw  863 ; delta step of Findx =  78
    .dw  857 ; delta step of Findx =  79
    .dw  852 ; delta step of Findx =  80
    .dw  848 ; delta step of Findx =  81
    .dw  843 ; delta step of Findx =  82
    .dw  839 ; delta step of Findx =  83
    .dw  834 ; delta step of Findx =  84
    .dw  828 ; delta step of Findx =  85
    .dw  824 ; delta step of Findx =  86
    .dw  819 ; delta step of Findx =  87
    .dw  815 ; delta step of Findx =  88
    .dw  812 ; delta step of Findx =  89
    .dw  807 ; delta step of Findx =  90
    .dw  803 ; delta step of Findx =  91
    .dw  798 ; delta step of Findx =  92
    .dw  794 ; delta step of Findx =  93
    .dw  789 ; delta step of Findx =  94
    .dw  786 ; delta step of Findx =  95
    .dw  750 ; delta step of Findx =  96
    .dw  773 ; delta step of Findx =  97
    .dw  765 ; delta step of Findx =  98
    .dw  758 ; delta step of Findx =  99
    .dw  750 ; delta step of Findx = 100
    .dw  743 ; delta step of Findx = 101
    .dw  735 ; delta step of Findx = 102
    .dw  728 ; delta step of Findx = 103
    .dw  722 ; delta step of Findx = 104
    .dw  685 ; delta step of Findx = 105
    .dw  708 ; delta step of Findx = 106
    .dw  701 ; delta step of Findx = 107
    .dw  695 ; delta step of Findx = 108
    .dw  689 ; delta step of Findx = 109
    .dw  655 ; delta step of Findx = 110
    .dw  675 ; delta step of Findx = 111
    .dw  669 ; delta step of Findx = 112
    .dw  663 ; delta step of Findx = 113
    .dw  632 ; delta step of Findx = 114
    .dw  653 ; delta step of Findx = 115
    .dw  647 ; delta step of Findx = 116
    .dw  641 ; delta step of Findx = 117
    .dw  636 ; delta step of Findx = 118
    .dw  617 ; delta step of Findx = 119
    .dw  626 ; delta step of Findx = 120
    .dw  620 ; delta step of Findx = 121
    .dw  615 ; delta step of Findx = 122
    .dw  586 ; delta step of Findx = 123
    .dw  605 ; delta step of Findx = 124
    .dw  600 ; delta step of Findx = 125
    .dw  596 ; delta step of Findx = 126
    .dw  591 ; delta step of Findx = 127
    .dw  575 ; delta step of Findx = 128
    .dw  582 ; delta step of Findx = 129
    .dw  578 ; delta step of Findx = 130
    .dw  573 ; delta step of Findx = 131
    .dw  546 ; delta step of Findx = 132
    .dw  564 ; delta step of Findx = 133
    .dw  560 ; delta step of Findx = 134
    .dw  555 ; delta step of Findx = 135
    .dw  552 ; delta step of Findx = 136
    .dw  537 ; delta step of Findx = 137
    .dw  543 ; delta step of Findx = 138
    .dw  540 ; delta step of Findx = 139
    .dw  536 ; delta step of Findx = 140
    .dw  522 ; delta step of Findx = 141
    .dw  528 ; delta step of Findx = 142
    .dw  525 ; delta step of Findx = 143
    .dw  521 ; delta step of Findx = 144
    .dw  518 ; delta step of Findx = 145
    .dw  503 ; delta step of Findx = 146
    .dw  510 ; delta step of Findx = 147
    .dw  507 ; delta step of Findx = 148
    .dw  504 ; delta step of Findx = 149
    .dw  490 ; delta step of Findx = 150
    .dw  487 ; delta step of Findx = 151
    .dw  494 ; delta step of Findx = 152
    .dw  491 ; delta step of Findx = 153
    .dw  478 ; delta step of Findx = 154
    .dw  475 ; delta step of Findx = 155
    .dw  482 ; delta step of Findx = 156
    .dw  477 ; delta step of Findx = 157
    .dw  474 ; delta step of Findx = 158
    .dw  462 ; delta step of Findx = 159
    .dw  468 ; delta step of Findx = 160
    .dw  467 ; delta step of Findx = 161
    .dw  464 ; delta step of Findx = 162
    .dw  452 ; delta step of Findx = 163
    .dw  449 ; delta step of Findx = 164
    .dw  455 ; delta step of Findx = 165
    .dw  452 ; delta step of Findx = 166
    .dw  449 ; delta step of Findx = 167
    .dw  438 ; delta step of Findx = 168
    .dw  435 ; delta step of Findx = 169
    .dw  441 ; delta step of Findx = 170
    .dw  438 ; delta step of Findx = 171
    .dw  428 ; delta step of Findx = 172
    .dw  425 ; delta step of Findx = 173
    .dw  422 ; delta step of Findx = 174
    .dw  429 ; delta step of Findx = 175
    .dw  435 ; delta step of Findx = 176
    .dw  415 ; delta step of Findx = 177
    .dw  414 ; delta step of Findx = 178
    .dw  419 ; delta step of Findx = 179
    .dw  417 ; delta step of Findx = 180
    .dw  419 ; delta step of Findx = 181
    .dw  405 ; delta step of Findx = 182
    .dw  410 ; delta step of Findx = 183
    .dw  408 ; delta step of Findx = 184
    .dw  397 ; delta step of Findx = 185
    .dw  396 ; delta step of Findx = 186
    .dw  393 ; delta step of Findx = 187
    .dw  399 ; delta step of Findx = 188
    .dw  403 ; delta step of Findx = 189
    .dw  387 ; delta step of Findx = 190
    .dw  410 ; delta step of Findx = 191
    .dw  390 ; delta step of Findx = 192
    .dw  389 ; delta step of Findx = 193
    .dw  379 ; delta step of Findx = 194
    .dw  375 ; delta step of Findx = 195
    .dw  380 ; delta step of Findx = 196
    .dw  368 ; delta step of Findx = 197
    .dw  372 ; delta step of Findx = 198
    .dw  361 ; delta step of Findx = 199
    .dw  358 ; delta step of Findx = 200
    .dw  353 ; delta step of Findx = 201
    .dw  350 ; delta step of Findx = 202
    .dw  354 ; delta step of Findx = 203
    .dw  344 ; delta step of Findx = 204
    .dw  347 ; delta step of Findx = 205
    .dw  337 ; delta step of Findx = 206
    .dw  327 ; delta step of Findx = 207
    .dw  331 ; delta step of Findx = 208
    .dw  328 ; delta step of Findx = 209
    .dw  326 ; delta step of Findx = 210
    .dw  323 ; delta step of Findx = 211
    .dw  326 ; delta step of Findx = 212
    .dw  318 ; delta step of Findx = 213
    .dw  321 ; delta step of Findx = 214
    .dw  312 ; delta step of Findx = 215
    .dw  315 ; delta step of Findx = 216
    .dw  306 ; delta step of Findx = 217
    .dw  305 ; delta step of Findx = 218
    .dw  302 ; delta step of Findx = 219
    .dw  299 ; delta step of Findx = 220
    .dw  303 ; delta step of Findx = 221
    .dw  294 ; delta step of Findx = 222
    .dw  297 ; delta step of Findx = 223
    .dw  290 ; delta step of Findx = 224
    .dw  293 ; delta step of Findx = 225
    .dw  285 ; delta step of Findx = 226
    .dw  282 ; delta step of Findx = 227
    .dw  281 ; delta step of Findx = 228
    .dw  279 ; delta step of Findx = 229
    .dw  277 ; delta step of Findx = 230
    .dw  276 ; delta step of Findx = 231
    .dw  273 ; delta step of Findx = 232
    .dw  271 ; delta step of Findx = 233
    .dw  273 ; delta step of Findx = 234
    .dw  267 ; delta step of Findx = 235
    .dw  265 ; delta step of Findx = 236
    .dw  264 ; delta step of Findx = 237
    .dw  261 ; delta step of Findx = 238
    .dw  259 ; delta step of Findx = 239
    .dw  258 ; delta step of Findx = 240
    .dw  256 ; delta step of Findx = 241
    .dw  253 ; delta step of Findx = 242
    .dw  252 ; delta step of Findx = 243
    .dw  250 ; delta step of Findx = 244
    .dw  249 ; delta step of Findx = 245
    .dw  247 ; delta step of Findx = 246
    .dw  241 ; delta step of Findx = 247
    .dw  244 ; delta step of Findx = 248
    .dw  241 ; delta step of Findx = 249
    .dw  240 ; delta step of Findx = 250
    .dw  238 ; delta step of Findx = 251
    .dw  237 ; delta step of Findx = 252
    .dw  235 ; delta step of Findx = 253
    .dw  234 ; delta step of Findx = 254
    .dw  233 ; delta step of Findx = 255
    .dw  232 ; delta step of Findx = 256
    .dw  230 ; delta step of Findx = 257
    .dw  224 ; delta step of Findx = 258
    .dw  225 ; delta step of Findx = 259
    .dw  226 ; delta step of Findx = 260
    .dw  224 ; delta step of Findx = 261
    .dw  222 ; delta step of Findx = 262
    .dw  218 ; delta step of Findx = 263
    .dw  219 ; delta step of Findx = 264
    .dw  215 ; delta step of Findx = 265
    .dw  216 ; delta step of Findx = 266
    .dw  217 ; delta step of Findx = 267
    .dw  213 ; delta step of Findx = 268
    .dw  214 ; delta step of Findx = 269
    .dw  212 ; delta step of Findx = 270
    .dw  212 ; delta step of Findx = 271
    .dw  211 ; delta step of Findx = 272
    .dw  209 ; delta step of Findx = 273
    .dw  208 ; delta step of Findx = 274
    .dw  206 ; delta step of Findx = 275
    .dw  202 ; delta step of Findx = 276
    .dw  203 ; delta step of Findx = 277
    .dw  203 ; delta step of Findx = 278
    .dw  200 ; delta step of Findx = 279
    .dw  200 ; delta step of Findx = 280
    .dw  198 ; delta step of Findx = 281
    .dw  197 ; delta step of Findx = 282
    .dw  197 ; delta step of Findx = 283
    .dw  195 ; delta step of Findx = 284
    .dw  192 ; delta step of Findx = 285
    .dw  194 ; delta step of Findx = 286
    .dw  194 ; delta step of Findx = 287
    .dw  191 ; delta step of Findx = 288
    .dw  191 ; delta step of Findx = 289
    .dw  189 ; delta step of Findx = 290
    .dw  190 ; delta step of Findx = 291
    .dw  188 ; delta step of Findx = 292
    .dw  186 ; delta step of Findx = 293
    .dw  183 ; delta step of Findx = 294
    .dw  181 ; delta step of Findx = 295
    .dw  179 ; delta step of Findx = 296
    .dw  179 ; delta step of Findx = 297
    .dw  177 ; delta step of Findx = 298
    .dw  175 ; delta step of Findx = 299
    .dw  174 ; delta step of Findx = 300
    .dw  171 ; delta step of Findx = 301
    .dw  169 ; delta step of Findx = 302
    .dw  168 ; delta step of Findx = 303
    .dw  166 ; delta step of Findx = 304
    .dw  165 ; delta step of Findx = 305
    .dw  163 ; delta step of Findx = 306
    .dw  162 ; delta step of Findx = 307
    .dw  161 ; delta step of Findx = 308
    .dw  160 ; delta step of Findx = 309
    .dw  158 ; delta step of Findx = 310
    .dw  158 ; delta step of Findx = 311
    .dw  156 ; delta step of Findx = 312
    .dw  155 ; delta step of Findx = 313
    .dw  153 ; delta step of Findx = 314
    .dw  152 ; delta step of Findx = 315
    .dw  150 ; delta step of Findx = 316
    .dw  150 ; delta step of Findx = 317
    .dw  149 ; delta step of Findx = 318
    .dw  147 ; delta step of Findx = 319
    .dw  146 ; delta step of Findx = 320
    .dw  144 ; delta step of Findx = 321
    .dw  143 ; delta step of Findx = 322
    .dw  142 ; delta step of Findx = 323
    .dw  141 ; delta step of Findx = 324
    .dw  140 ; delta step of Findx = 325
    .dw  139 ; delta step of Findx = 326
    .dw  138 ; delta step of Findx = 327
    .dw  137 ; delta step of Findx = 328
    .dw  136 ; delta step of Findx = 329
    .dw  135 ; delta step of Findx = 330
    .dw  134 ; delta step of Findx = 331
    .dw  133 ; delta step of Findx = 332
    .dw  132 ; delta step of Findx = 333
    .dw  131 ; delta step of Findx = 334
    .dw  130 ; delta step of Findx = 335
    .dw  128 ; delta step of Findx = 336
    .dw  128 ; delta step of Findx = 337
    .dw  127 ; delta step of Findx = 338
    .dw  126 ; delta step of Findx = 339
    .dw  126 ; delta step of Findx = 340
    .dw  125 ; delta step of Findx = 341
    .dw  124 ; delta step of Findx = 342
    .dw  123 ; delta step of Findx = 343
    .dw  122 ; delta step of Findx = 344
    .dw  121 ; delta step of Findx = 345
    .dw  121 ; delta step of Findx = 346
    .dw  120 ; delta step of Findx = 347
    .dw  119 ; delta step of Findx = 348
    .dw  118 ; delta step of Findx = 349
    .dw  117 ; delta step of Findx = 350
    .dw  116 ; delta step of Findx = 351
    .dw  116 ; delta step of Findx = 352
    .dw  115 ; delta step of Findx = 353
    .dw  114 ; delta step of Findx = 354
    .dw  113 ; delta step of Findx = 355
    .dw  112 ; delta step of Findx = 356
    .dw  112 ; delta step of Findx = 357
    .dw  110 ; delta step of Findx = 358
    .dw  111 ; delta step of Findx = 359
    .dw  110 ; delta step of Findx = 360
    .dw  109 ; delta step of Findx = 361
    .dw  109 ; delta step of Findx = 362
    .dw  108 ; delta step of Findx = 363
    .dw  107 ; delta step of Findx = 364
    .dw  107 ; delta step of Findx = 365
    .dw  106 ; delta step of Findx = 366
    .dw  106 ; delta step of Findx = 367
    .dw  105 ; delta step of Findx = 368
    .dw  103 ; delta step of Findx = 369
    .dw  103 ; delta step of Findx = 370
    .dw  103 ; delta step of Findx = 371
    .dw  102 ; delta step of Findx = 372
    .dw  101 ; delta step of Findx = 373
    .dw  101 ; delta step of Findx = 374
    .dw  101 ; delta step of Findx = 375
    .dw  100 ; delta step of Findx = 376
    .dw  100 ; delta step of Findx = 377
    .dw   99 ; delta step of Findx = 378
    .dw   98 ; delta step of Findx = 379
    .dw   98 ; delta step of Findx = 380
    .dw   97 ; delta step of Findx = 381
    .dw   97 ; delta step of Findx = 382
    .dw   96 ; delta step of Findx = 383
    .dw   96 ; delta step of Findx = 384
    .dw   95 ; delta step of Findx = 385
    .dw   95 ; delta step of Findx = 386
    .dw   94 ; delta step of Findx = 387
    .dw   94 ; delta step of Findx = 388
    .dw   94 ; delta step of Findx = 389
    .dw   93 ; delta step of Findx = 390
    .dw   92 ; delta step of Findx = 391
    .dw   90 ; delta step of Findx = 392
    .dw   89 ; delta step of Findx = 393
    .dw   89 ; delta step of Findx = 394
    .dw   87 ; delta step of Findx = 395
    .dw   87 ; delta step of Findx = 396
    .dw   86 ; delta step of Findx = 397
    .dw   85 ; delta step of Findx = 398
    .dw   84 ; delta step of Findx = 399
    .dw   83 ; delta step of Findx = 400
    .dw   83 ; delta step of Findx = 401
    .dw   82 ; delta step of Findx = 402
    .dw   81 ; delta step of Findx = 403
    .dw   80 ; delta step of Findx = 404
    .dw   80 ; delta step of Findx = 405
    .dw   79 ; delta step of Findx = 406
    .dw   78 ; delta step of Findx = 407
    .dw   78 ; delta step of Findx = 408
    .dw   77 ; delta step of Findx = 409
    .dw   77 ; delta step of Findx = 410
    .dw   77 ; delta step of Findx = 411
    .dw   76 ; delta step of Findx = 412
    .dw   75 ; delta step of Findx = 413
    .dw   74 ; delta step of Findx = 414
    .dw   74 ; delta step of Findx = 415
    .dw   73 ; delta step of Findx = 416
    .dw   72 ; delta step of Findx = 417
    .dw   72 ; delta step of Findx = 418
    .dw   71 ; delta step of Findx = 419
    .dw   71 ; delta step of Findx = 420
    .dw   71 ; delta step of Findx = 421
    .dw   70 ; delta step of Findx = 422
    .dw   69 ; delta step of Findx = 423
    .dw   69 ; delta step of Findx = 424
    .dw   68 ; delta step of Findx = 425
    .dw   68 ; delta step of Findx = 426
    .dw   67 ; delta step of Findx = 427
    .dw   67 ; delta step of Findx = 428
    .dw   66 ; delta step of Findx = 429
    .dw   66 ; delta step of Findx = 430
    .dw   66 ; delta step of Findx = 431
    .dw   65 ; delta step of Findx = 432
    .dw   64 ; delta step of Findx = 433
    .dw   64 ; delta step of Findx = 434
    .dw   63 ; delta step of Findx = 435
    .dw   63 ; delta step of Findx = 436
    .dw   63 ; delta step of Findx = 437
    .dw   62 ; delta step of Findx = 438
    .dw   62 ; delta step of Findx = 439
    .dw   61 ; delta step of Findx = 440
    .dw   61 ; delta step of Findx = 441
    .dw   60 ; delta step of Findx = 442
    .dw   60 ; delta step of Findx = 443
    .dw   60 ; delta step of Findx = 444
    .dw   59 ; delta step of Findx = 445
    .dw   59 ; delta step of Findx = 446
    .dw   58 ; delta step of Findx = 447
    .dw   58 ; delta step of Findx = 448
    .dw   58 ; delta step of Findx = 449
    .dw   57 ; delta step of Findx = 450
    .dw   57 ; delta step of Findx = 451
    .dw   57 ; delta step of Findx = 452
    .dw   56 ; delta step of Findx = 453
    .dw   56 ; delta step of Findx = 454
    .dw   55 ; delta step of Findx = 455
    .dw   55 ; delta step of Findx = 456
    .dw   55 ; delta step of Findx = 457
    .dw   54 ; delta step of Findx = 458
    .dw   54 ; delta step of Findx = 459
    .dw   54 ; delta step of Findx = 460
    .dw   54 ; delta step of Findx = 461
    .dw   53 ; delta step of Findx = 462
    .dw   53 ; delta step of Findx = 463
    .dw   53 ; delta step of Findx = 464
    .dw   52 ; delta step of Findx = 465
    .dw   52 ; delta step of Findx = 466
    .dw   52 ; delta step of Findx = 467
    .dw   51 ; delta step of Findx = 468
    .dw   51 ; delta step of Findx = 469
    .dw   51 ; delta step of Findx = 470
    .dw   51 ; delta step of Findx = 471
    .dw   50 ; delta step of Findx = 472
    .dw   50 ; delta step of Findx = 473
    .dw   49 ; delta step of Findx = 474
    .dw   49 ; delta step of Findx = 475
    .dw   49 ; delta step of Findx = 476
    .dw   49 ; delta step of Findx = 477
    .dw   48 ; delta step of Findx = 478
    .dw   48 ; delta step of Findx = 479
    .dw   48 ; delta step of Findx = 480
    .dw   48 ; delta step of Findx = 481
    .dw   48 ; delta step of Findx = 482
    .dw   47 ; delta step of Findx = 483
    .dw   47 ; delta step of Findx = 484

    .org 0x0A00

; from D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest\
; lastDelta5.xlsx, "F_List-SEEP"
; x = FindexH\L [ 0 to 484 ]
; y = start address in external SEEP [24C512]
; 485+1 * 2 bytes = 972 bytes [486 words]
SEEPadd:
   .dw 0, 12, 37, 50, 75, 88, 114, 127
   .dw 153, 166, 193, 207, 234, 248, 276, 290
   .dw 318, 332, 361, 376, 405, 420, 450, 465
   .dw 495, 510, 541, 557, 588, 604, 636, 652
   .dw 684, 700, 733, 750, 783, 800, 834, 851
   .dw 885, 902, 937, 955, 990, 1008, 1044, 1062
   .dw 1098, 1116, 1153, 1172, 1209, 1228, 1266, 1285
   .dw 1323, 1342, 1381, 1401, 1440, 1460, 1500, 1520
   .dw 1560, 1580, 1621, 1642, 1683, 1704, 1746, 1767
   .dw 1809, 1830, 1873, 1895, 1938, 1960, 2004, 2026
   .dw 2070, 2092, 2137, 2160, 2205, 2228, 2274, 2297
   .dw 2343, 2366, 2413, 2437, 2484, 2508, 2556, 2580
   .dw 2628, 2652, 2677, 2702, 2727, 2752, 2778, 2804
   .dw 2830, 2856, 2883, 2910, 2937, 2964, 2992, 3020
   .dw 3048, 3076, 3105, 3134, 3163, 3192, 3222, 3252
   .dw 3282, 3312, 3343, 3374, 3405, 3436, 3468, 3500
   .dw 3532, 3564, 3597, 3630, 3663, 3696, 3730, 3764
   .dw 3798, 3832, 3867, 3902, 3937, 3972, 4008, 4044
   .dw 4080, 4116, 4153, 4190, 4227, 4264, 4302, 4340
   .dw 4378, 4416, 4455, 4494, 4533, 4572, 4612, 4652
   .dw 4692, 4732, 4773, 4814, 4855, 4896, 4938, 4980
   .dw 5022, 5064, 5107, 5150, 5193, 5236, 5280, 5324
   .dw 5368, 5412, 5457, 5502, 5547, 5592, 5638, 5684
   .dw 5730, 5776, 5823, 5870, 5917, 5964, 6012, 6060
   .dw 6108, 6156, 6205, 6254, 6303, 6353, 6403, 6454
   .dw 6505, 6557, 6609, 6662, 6715, 6769, 6823, 6878
   .dw 6933, 6989, 7045, 7102, 7159, 7217, 7275, 7334
   .dw 7393, 7453, 7513, 7574, 7635, 7697, 7759, 7822
   .dw 7885, 7949, 8013, 8078, 8143, 8209, 8275, 8342
   .dw 8409, 8477, 8545, 8614, 8683, 8753, 8823, 8894
   .dw 8965, 9037, 9109, 9182, 9255, 9329, 9403, 9478
   .dw 9553, 9629, 9705, 9782, 9859, 9937, 10015, 10094
   .dw 10173, 10253, 10333, 10414, 10495, 10577, 10659, 10742
   .dw 10825, 10909, 10993, 11078, 11163, 11249, 11335, 11422
   .dw 11509, 11597, 11685, 11774, 11863, 11953, 12043, 12134
   .dw 12225, 12317, 12409, 12502, 12595, 12689, 12783, 12878
   .dw 12973, 13069, 13165, 13262, 13359, 13457, 13556, 13656
   .dw 13757, 13859, 13962, 14066, 14171, 14277, 14384, 14492
   .dw 14601, 14711, 14822, 14934, 15047, 15161, 15276, 15392
   .dw 15509, 15627, 15746, 15866, 15987, 16109, 16232, 16356
   .dw 16481, 16607, 16734, 16862, 16991, 17121, 17252, 17384
   .dw 17517, 17651, 17786, 17922, 18059, 18197, 18336, 18476
   .dw 18617, 18759, 18902, 19046, 19191, 19337, 19484, 19632
   .dw 19781, 19931, 20082, 20234, 20387, 20541, 20696, 20852
   .dw 21009, 21167, 21326, 21486, 21647, 21809, 21972, 22136
   .dw 22301, 22467, 22634, 22802, 22971, 23141, 23312, 23484
   .dw 23657, 23831, 24006, 24182, 24359, 24537, 24716, 24896
   .dw 25077, 25259, 25442, 25626, 25811, 25997, 26184, 26372
   .dw 26561, 26751, 26942, 27134, 27327, 27521, 27717, 27915
   .dw 28115, 28317, 28521, 28727, 28935, 29145, 29357, 29571
   .dw 29787, 30005, 30225, 30447, 30671, 30897, 31125, 31355
   .dw 31587, 31821, 32057, 32295, 32535, 32777, 33021, 33267
   .dw 33515, 33765, 34017, 34271, 34527, 34785, 35045, 35307
   .dw 35571, 35837, 36105, 36375, 36647, 36921, 37197, 37475
   .dw 37755, 38037, 38321, 38607, 38895, 39185, 39477, 39771
   .dw 40067, 40365, 40665, 40967, 41271, 41577, 41885, 42195
   .dw 42507, 42821, 43137, 43455, 43775, 44097, 44421, 44747
   .dw 45075, 45405, 45737, 46071, 46407, 46745, 47085, 47427
   .dw 47771, 48117, 48465, 48815, 49167, 49521, 49877, 50235
   .dw 50595, 50957, 51321, 51687, 52055, 52425, 52797, 53171
   .dw 53547, 53925, 54305, 54687, 55071, 55457

;=== ===

    .org 0x0C00

; from D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest\
; lastDelta4.xlsx, "NbitsTb"
; x = FindexH\L [ 0 to 484 ]
; y = NbitsH_\L
; 485 * 2 bytes = 970 bytes [485 words]
NbitsTb:
   .dw 96, 97, 98, 99
   .dw 100, 101, 102, 103
   .dw 104, 105, 106, 107
   .dw 108, 109, 110, 111
   .dw 112, 113, 114, 115
   .dw 116, 117, 118, 119
   .dw 120, 121, 122, 123
   .dw 124, 125, 126, 127
   .dw 128, 129, 130, 131
   .dw 132, 133, 134, 135
   .dw 136, 137, 138, 139
   .dw 140, 141, 142, 143
   .dw 144, 145, 146, 147
   .dw 148, 149, 150, 151
   .dw 152, 153, 154, 155
   .dw 156, 157, 158, 159
   .dw 160, 161, 162, 163
   .dw 164, 165, 166, 167
   .dw 168, 169, 170, 171
   .dw 172, 173, 174, 175
   .dw 176, 177, 178, 179
   .dw 180, 181, 182, 183
   .dw 184, 185, 186, 187
   .dw 188, 189, 190, 191
   .dw 192, 194, 196, 198
   .dw 200, 202, 204, 206
   .dw 208, 210, 212, 214
   .dw 216, 218, 220, 222
   .dw 224, 226, 228, 230
   .dw 232, 234, 236, 238
   .dw 240, 242, 244, 246
   .dw 248, 250, 252, 254
   .dw 256, 258, 260, 262
   .dw 264, 266, 268, 270
   .dw 272, 274, 276, 278
   .dw 280, 282, 284, 286
   .dw 288, 290, 292, 294
   .dw 296, 298, 300, 302
   .dw 304, 306, 308, 310
   .dw 312, 314, 316, 318
   .dw 320, 322, 324, 326
   .dw 328, 330, 332, 334
   .dw 336, 338, 340, 342
   .dw 344, 346, 348, 350
   .dw 352, 354, 356, 358
   .dw 360, 362, 364, 366
   .dw 368, 370, 372, 374
   .dw 376, 378, 380, 382
   .dw 384, 386, 388, 392
   .dw 396, 400, 404, 408
   .dw 412, 416, 420, 424
   .dw 428, 432, 436, 440
   .dw 444, 448, 452, 456
   .dw 460, 464, 468, 472
   .dw 476, 480, 484, 488
   .dw 492, 496, 500, 504
   .dw 508, 512, 516, 520
   .dw 524, 528, 532, 536
   .dw 540, 544, 548, 552
   .dw 556, 560, 564, 568
   .dw 572, 576, 580, 584
   .dw 588, 592, 596, 600
   .dw 604, 608, 612, 616
   .dw 620, 624, 628, 632
   .dw 636, 640, 644, 648
   .dw 652, 656, 660, 664
   .dw 668, 672, 676, 680
   .dw 684, 688, 692, 696
   .dw 700, 704, 708, 712
   .dw 716, 720, 724, 728
   .dw 732, 736, 740, 744
   .dw 748, 752, 756, 760
   .dw 764, 768, 772, 776
   .dw 784, 792, 800, 808
   .dw 816, 824, 832, 840
   .dw 848, 856, 864, 872
   .dw 880, 888, 896, 904
   .dw 912, 920, 928, 936
   .dw 944, 952, 960, 968
   .dw 976, 984, 992, 1000
   .dw 1008, 1016, 1024, 1032
   .dw 1040, 1048, 1056, 1064
   .dw 1072, 1080, 1088, 1096
   .dw 1104, 1112, 1120, 1128
   .dw 1136, 1144, 1152, 1160
   .dw 1168, 1176, 1184, 1192
   .dw 1200, 1208, 1216, 1224
   .dw 1232, 1240, 1248, 1256
   .dw 1264, 1272, 1280, 1288
   .dw 1296, 1304, 1312, 1320
   .dw 1328, 1336, 1344, 1352
   .dw 1360, 1368, 1376, 1384
   .dw 1392, 1400, 1408, 1416
   .dw 1424, 1432, 1440, 1448
   .dw 1456, 1464, 1472, 1480
   .dw 1488, 1496, 1504, 1512
   .dw 1520, 1528, 1536, 1544
   .dw 1552, 1568, 1584, 1600
   .dw 1616, 1632, 1648, 1664
   .dw 1680, 1696, 1712, 1728
   .dw 1744, 1760, 1776, 1792
   .dw 1808, 1824, 1840, 1856
   .dw 1872, 1888, 1904, 1920
   .dw 1936, 1952, 1968, 1984
   .dw 2000, 2016, 2032, 2048
   .dw 2064, 2080, 2096, 2112
   .dw 2128, 2144, 2160, 2176
   .dw 2192, 2208, 2224, 2240
   .dw 2256, 2272, 2288, 2304
   .dw 2320, 2336, 2352, 2368
   .dw 2384, 2400, 2416, 2432
   .dw 2448, 2464, 2480, 2496
   .dw 2512, 2528, 2544, 2560
   .dw 2576, 2592, 2608, 2624
   .dw 2640, 2656, 2672, 2688
   .dw 2704, 2720, 2736, 2752
   .dw 2768, 2784, 2800, 2816
   .dw 2832, 2848, 2864, 2880
   .dw 2896, 2912, 2928, 2944
   .dw 2960, 2976, 2992, 3008
   .dw 3024, 3040, 3056, 3072
   .dw 3088

;=== ===

    .org 0x0E00

; from D:\L500\Koko_all\Work\projects\EarTest\DeltaAutoTest\
; lastDelta5.xlsx, "SinCos0"
; x = FindexH\L [ 0 to 484 ]
; y = cos0_diff*8*256 + sin0H\L [if bandIdx = 0)
; y = cos0_diff*4*256 + sin0H\L [if bandIdx > 0)
; 485 * 2 bytes = 970 bytes [485 words]
SinCos0:
   .dw 1072, 3109, 3098, 5135
   .dw 7173, 7163, 9201, 11239
   .dw 11229, 13268, 13259, 15298
   .dw 15289, 17328, 17319, 19359
   .dw 19351, 21391, 21383, 23423
   .dw 23415, 23407, 25448, 25441
   .dw 27481, 27474, 27467, 29509
   .dw 29502, 29495, 31537, 31530
   .dw 31524, 33566, 33560, 33554
   .dw 33548, 35590, 35584, 35578
   .dw 37621, 37615, 37610, 37604
   .dw 39647, 39642, 39637, 39632
   .dw 39627, 41670, 41665, 41660
   .dw 41655, 41651, 43694, 43690
   .dw 43685, 43681, 43676, 45720
   .dw 45716, 45712, 45707, 45703
   .dw 45699, 47743, 47739, 47735
   .dw 47732, 47728, 47724, 47720
   .dw 49765, 49761, 49757, 49754
   .dw 49750, 49747, 49744, 49740
   .dw 51785, 51781, 51778, 51775
   .dw 51772, 51769, 51766, 51762
   .dw 51759, 53804, 53801, 53798
   .dw 53795, 53793, 53790, 53787
   .dw 53784, 27155, 28173, 28168
   .dw 28163, 28158, 28153, 28148
   .dw 29167, 29162, 29158, 29153
   .dw 29149, 29144, 29140, 29136
   .dw 30156, 30151, 30147, 30144
   .dw 30140, 30136, 30132, 30128
   .dw 30125, 30121, 31142, 31138
   .dw 31135, 31132, 31128, 31125
   .dw 31122, 31119, 31116, 31113
   .dw 31110, 31107, 31104, 32125
   .dw 32122, 32120, 32117, 32114
   .dw 32112, 32109, 32106, 32104
   .dw 32101, 32099, 32097, 32094
   .dw 32092, 32089, 32087, 32085
   .dw 33107, 33104, 33102, 33100
   .dw 33098, 33096, 33094, 33092
   .dw 33090, 33088, 33086, 33084
   .dw 33082, 33080, 33078, 33076
   .dw 33074, 33073, 33071, 33069
   .dw 33067, 33066, 33064, 33062
   .dw 33060, 33059, 33057, 33056
   .dw 34078, 34076, 34075, 34073
   .dw 34072, 34070, 34069, 34067
   .dw 34066, 34064, 34063, 34061
   .dw 34060, 34059, 34057, 34054
   .dw 34051, 34049, 34046, 34044
   .dw 34041, 34039, 34037, 34034
   .dw 34032, 34030, 34028, 34025
   .dw 34023, 34021, 34019, 34017
   .dw 34015, 34013, 35035, 35034
   .dw 35032, 35030, 35028, 35026
   .dw 35025, 35023, 35021, 35020
   .dw 35018, 35017, 35015, 35013
   .dw 35012, 35010, 35009, 35008
   .dw 35006, 35005, 35003, 35002
   .dw 35001, 34999, 34998, 34997
   .dw 34995, 34994, 34993, 34992
   .dw 34991, 34989, 34988, 34987
   .dw 34986, 34985, 34984, 34983
   .dw 34982, 34980, 34979, 34978
   .dw 34977, 34976, 34975, 34974
   .dw 34973, 34972, 34971, 34971
   .dw 34970, 34969, 34968, 34967
   .dw 34966, 34965, 34964, 34963
   .dw 34963, 34962, 34961, 34960
   .dw 34959, 34958, 34958, 34957
   .dw 34956, 34955, 34955, 34954
   .dw 34953, 34952, 34952, 34951
   .dw 34950, 34950, 34949, 34948
   .dw 34947, 34945, 34944, 35967
   .dw 35966, 35964, 35963, 35962
   .dw 35961, 35960, 35959, 35958
   .dw 35956, 35955, 35954, 35953
   .dw 35952, 35951, 35950, 35949
   .dw 35949, 35948, 35947, 35946
   .dw 35945, 35944, 35943, 35942
   .dw 35942, 35941, 35940, 35939
   .dw 35938, 35938, 35937, 35936
   .dw 35936, 35935, 35934, 35933
   .dw 35933, 35932, 35931, 35931
   .dw 35930, 35929, 35929, 35928
   .dw 35928, 35927, 35926, 35926
   .dw 35925, 35925, 35924, 35924
   .dw 35923, 35923, 35922, 35921
   .dw 35921, 35920, 35920, 35919
   .dw 35919, 35918, 35918, 35917
   .dw 35917, 35917, 35916, 35916
   .dw 35915, 35915, 35914, 35914
   .dw 35913, 35913, 35913, 35912
   .dw 35912, 35911, 35911, 35911
   .dw 35910, 35910, 35909, 35909
   .dw 35909, 35908, 35908, 35908
   .dw 35907, 35907, 35907, 35906
   .dw 35906, 35905, 35904, 35904
   .dw 35903, 35903, 35902, 35901
   .dw 35901, 35900, 35900, 35899
   .dw 35899, 35898, 35897, 35897
   .dw 35896, 35896, 35895, 35895
   .dw 35894, 35894, 35894, 35893
   .dw 35893, 35892, 35892, 35891
   .dw 35891, 35891, 35890, 35890
   .dw 35889, 35889, 35889, 35888
   .dw 35888, 35888, 35887, 35887
   .dw 35886, 35886, 35886, 35885
   .dw 35885, 35885, 35884, 35884
   .dw 35884, 35884, 35883, 35883
   .dw 35883, 35882, 35882, 35882
   .dw 35882, 35881, 35881, 35881
   .dw 35880, 35880, 35880, 35880
   .dw 35879, 35879, 35879, 35879
   .dw 35878, 35878, 35878, 35878
   .dw 35878, 35877, 35877, 35877
   .dw 35877, 35876, 35876, 35876
   .dw 35876, 35876, 35875, 35875
   .dw 35875, 35875, 35875, 35874
   .dw 35874, 35874, 35874, 35874
   .dw 35874, 35873, 35873, 35873
   .dw 35873

;========================================================

;====
;.ESEG
;====

;    .org 0x0000

.exit

/*
;----------------------------------------------------------------------
; DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT
;----------------------------------------------------------------------

*/
